define([ 'views/accountView' ], function(View) {

	APP_account = {};
	APP_account.ProtocalId = "";
	APP_account.stockAccount = "";
	APP_account.fundAccount = "";
	APP_account.signValue = "";
	APP_account.checkReviewTime = false;
	APP_account.account_page_flag = "1";
	APP_account.protocalElem = {};
	APP_account.protocalElemLength = 0;
	APP_account.isbiztype = "1 2";
	// 已签署协议的个数
	APP_account.hasSignSize = 0;
	// 证书序列号
	APP_account.sn = "";

	APP_account.selectedType = "";

	// 需要隐藏新开下挂按钮的类型
	APP_account.hide_button = "";
	// 单独开立深圳A股特殊传参
	APP_account.biztype_need = "";
	APP_account.account_num = "";

	APP_account.bindings = [ {
		element : '.sign-next-button',
		event : 'click',
		handler : nextSubmit
	}, {
		element : '#reBack',
		event : 'click',
		handler : returnPre
	}, {
		element : '.changeBtn',
		event : 'click',
		handler : changeClick
	}, {
		element : 'label.kh-a,label.zg-a,label.kh-b,label.zg-b',
		event : 'click',
		handler : chooseKH_ZG
	}, {
		element : 'a#choose-account-a,a#choose-account-b',
		event : 'click',
		handler : chooseAccount
	}, {
		element : '.label-checkbox',
		event : 'click',
		handler : checkChange
	} ];
	function returnPre() {
		if (!appParams.isback) {
			appParams.isback = "pwdset";
		}
		mainView.loadPage("/examResult.do?fnf=returnPass");
	}
	// 点击转户
	function changeClick() {
		APP_account.account_page_flag = "2";
		showStockArea2();
		checkChange();
	}
	// 点击页面内任意一个checkbox触发:更新协议列表和下一步按钮
	function checkChange() {
		setTimeout(function() {
			var check1002 = false;
			if (APP_account.haveStockAccount) {
				if (APP_account.account_page_flag == "2") {
					var sh_kh = $$("label.kh-a").find('input')[0].checked;
					var sh_zg = $$("label.zg-a").find('input')[0].checked;
					var sz_kh = $$("label.kh-b").find('input')[0].checked;
					var sz_zg = $$("label.zg-b").find('input')[0].checked;
					if (sh_kh || sh_zg || sz_kh || sz_zg) {
						check1002 = true;
					}
				} else {
					$$("input[name=accountStock]").each(function() {
						if (!check1002) {
							if (this.checked) {
								check1002 = true;
								return;
							}
						}
					});
				}
			}
			var check1003 = false;
			if (APP_account.haveFundAccount) {
				$$("input[name=accountFund]").each(function() {
					if (!check1003) {
						if (this.checked) {
							check1003 = true;
							return;
						}
					}
				});
			}
			reRenderProtocal(check1002, check1003);
			var flag = false;
			var checked_xy = $$("input[name='agreement']").prop('checked');
			if (APP_account.haveStockAccount && APP_account.haveFundAccount) {
				if (checked_xy && (check1002 || check1003)) {
					flag = true;
				}
			} else if (APP_account.haveStockAccount && !APP_account.haveFundAccount) {
				if (checked_xy && check1002) {
					flag = true;
				}
			} else if (!APP_account.haveStockAccount && APP_account.haveFundAccount) {
				if (checked_xy && check1003) {
					flag = true;
				}
			} else {
				flag = checked_xy;
			}
			if (flag) {
				$$('.button-fill').removeClass('disabled');
			} else {
				$$('.button-fill').addClass('disabled');
			}
		}, 100);
	}

	function showStockArea2() {
		$$("#accountStockArea1").hide();
		$$(".content-block-foot").hide();
		$$(".change-list-block").show();
		if (APP_account.checkReviewTime) {
			$$(".border").show();
		} else {
			$$(".border").hide();
		}
	}
	function chooseKH_ZG() {
		var _THIS = $$(this);
		var t = _THIS.hasClass("kh-a") ? "11" : "";
		t = t || (_THIS.hasClass("zg-a") ? "12" : "");
		t = t || (_THIS.hasClass("kh-b") ? "21" : "");
		t = t || (_THIS.hasClass("zg-b") ? "22" : "");
		if (t) {
			var other = {
				'11' : 'zg-a',
				'12' : 'kh-a',
				'21' : 'zg-b',
				'22' : 'kh-b'
			};
			_THIS.parents('li').find('.' + other[t] + ' input').prop('checked', false);
			setTimeout(function() {
				if (t == '11' || t == '12') {
					if (APP_account.checkReviewTime && _THIS.parents('li').find('.zg-a input')[0].checked) {
						$$("#account-old-change-a").show();
					} else {
						$$("#account-old-change-a").hide();
						$$("#choose-account-a .item-after").html("请选择股东账号").css("color", "#ccc");
					}
				} else if (t == '21' || t == '22') {
					if (APP_account.checkReviewTime && _THIS.parents('li').find('.zg-b input')[0].checked) {
						$$("#account-old-change-b").show();
					} else {
						$$("#account-old-change-b").hide();
						$$("#choose-account-b .item-after").html("请选择股东账号").css("color", "#ccc");
					}
				}
			}, 20);
		}
	}
	function chooseAccount() {
		var THIS = this;
		var accountType = (THIS.id == 'choose-account-a') ? "1" : "2";
		khApp.showIndicator();
		var t1 = new Date().getTime();
		$$.ajax({
			url : '/zhongDengAccountReq.do?rnd=' + t1,
			method : "POST",
			timeout : 40000,
			success : function(d) {
				_CMN.log("csdcQrySucc:" + (new Date().getTime() - t1));
				var data = JSON.parse(d);
				khApp.hideIndicator();
				if (data.errorNo !== 0) {
					alert({
						'text' : '当前无法查询账户，系统自动选择账户下挂'
					});
					return;
				}
				var list = accountType == "1" ? data.openedAccounts.shStockAccount : data.openedAccounts.szStockAccount;
				if (!list || list.length == 0) {
					alert({
						'text' : '没有已开通账户可选，请新开账户'
					});
					return;
				}
				var accOld = $$("#choose-account-" + (accountType == "1" ? "a" : "b") + " .item-after").html();
				var _html = "";
				for (var i = 0; i < list.length; i++) {
					var acc = list[i].stock_account;
					var name = list[i].csdc_relationship_organ_name || '';
					_html += '<div class="item ' + (accOld == acc ? "active" : "") + '"><span class="item-num">' + acc + '</span><span class="item-name">' + name + '</span></div>';
				}
				khApp.modal({
					title : '<h3 class="sign-mask-title">请选择股东账户<img src="' + (SERVICE_DOMAIN_URL || "") + '/template-3.0/img/close-1.png" class="mask-close" alt=""></h3>',
					text : '<div class="account-choose-con">' + _html + '</div>',
					buttons : []
				});
				$$(".mask-close").off("click").on("click", function() {
					khApp.closeModal();
				});
				$$(".account-choose-con .item").off("click").on("click", function() {
					var _ele = $$(".account-choose-con .item");
					for (var i = 0; i < _ele.length; i++) {
						_ele.eq(i).removeClass("active");
					}
					$$(this).addClass("active");
					$$("#choose-account-" + (accountType == "1" ? "a" : "b") + " .item-after").html($$(this).find(".item-num").text()).css("color", "#333");
					khApp.closeModal();
				});
			},
			error : function() {
				_CMN.log("csdcQryError:" + (new Date().getTime() - t1));
				khApp.hideIndicator();
				alert({
					'text' : '当前无法查询账户，系统自动选择账户下挂'
				});
			},
			timeout : function() {
				_CMN.log("csdcQryTimeout:" + (new Date().getTime() - t1));
				khApp.hideIndicator();
				alert({
					'text' : '当前无法查询账户，系统自动选择账户下挂'
				});
			}
		});
	}

	function alert(c) {
		khApp.modal({
			title : '<h3 class="account-modal-title">开户提示</h3>',
			text : '<div class="account-modal-con" style="text-align:center;">' + c.text + '</div>',
			buttons : [ {
				text : '<span style="color: #3793FE;">确定</span>',
				onClick : function() {
				}
			} ]
		});
	}

	function initPageItems(data) {
		if (APP_account.haveStockAccount) {
			APP_account.account_page_flag = data.account_page_flag;
			var stocklist = data.stockAccountInfoList || [];
			if (stocklist.length > 0) {
				if (!data.account_page_flag || data.account_page_flag != "2") {
					$$("#accountStock_sh").prop('checked', false);
					$$("#accountStock_sz").prop('checked', false);
					for (var i = 0; i < stocklist.length; i++) {
						var account_type = stocklist[i].account_type;
						var biz_op_type = stocklist[i].biz_op_type;
						if (account_type == "1" && biz_op_type == "1") {
							$$("#accountStock_sh").prop('checked', true);
						} else if (account_type == "2" && biz_op_type == "2") {
							$$("#accountStock_sz").prop('checked', true);
						}
					}
				} else {
					showStockArea2();
					$$("label.kh-a,label.zg-a,label.kh-b,label.zg-b").find('input').prop('checked', false);
					$$("#account-old-change-a").hide();
					$$("#account-old-change-b").hide();
					for (var i = 0; i < stocklist.length; i++) {
						var account_type = stocklist[i].account_type;
						var biz_op_type = stocklist[i].biz_op_type;
						var stock_account_under = stocklist[i].stock_account_under;
						var isNew = (biz_op_type == "1");
						if (account_type == "1" || account_type == "2") {
							var key = (account_type == "1") ? "a" : "b";
							$$("label.kh-" + key).find('input').prop('checked', isNew);
							$$("label.zg-" + key).find('input').prop('checked', !isNew);
							if (APP_account.checkReviewTime && !isNew) {
								$$("#account-old-change-" + key).show();
								if (stock_account_under && stock_account_under != ' ') {
									$$("#choose-account-" + key + " .item-after").html(stock_account_under).css("color", "#333");
								}
							}
						}
					}
				}
			}else{
				//如果显示了证券户,没有选证券户,选择了理财户,则需要将默认选择的证券户去除掉
				if(APP_account.haveFundAccount){
					var fundlist = data.fundAccountInfoList || [];
					if(fundlist.length>0){
						if (!data.account_page_flag || data.account_page_flag != "2") {
							$$("#accountStock_sh").prop('checked', false);
							$$("#accountStock_sz").prop('checked', false);
						}else{
							showStockArea2();
							$$("label.kh-a,label.zg-a,label.kh-b,label.zg-b").find('input').prop('checked', false);
							$$("#account-old-change-a").hide();
							$$("#account-old-change-b").hide();
						}
					}
				}
			}
		}
		if (APP_account.haveFundAccount) {
			var fundlist = data.fundAccountInfoList || [];
			if (fundlist.length > 0) {
				$$('input[name=accountFund]').prop('checked', false);
				for (var i = 0; i < fundlist.length; i++) {
					var obj = fundlist[i];
					if (obj.fund_code && $$('#accountFund_' + obj.fund_code).length > 0) {
						$$('#accountFund_' + obj.fund_code).prop('checked', true);
					}
				}
			}
		}
	}

	function nextSubmit() {
		var checbox = $$("input[name=agreement]")[0];
		if (!checbox.checked) {
			khApp.alert("请仔细阅读并同意签署以上协议");
			return;
		}
		APP_account.biztype = "";

		var stockAccount = "";
		var accountFund = "";

		if (APP_account.account_page_flag == "2") {
			var sh_kh = $$("label.kh-a").find('input')[0].checked;// 上海 - 新开
			var sh_zg = $$("label.zg-a").find('input')[0].checked;// 上海 - 转户
			var sz_kh = $$("label.kh-b").find('input')[0].checked;// 深圳 - 新开
			var sz_zg = $$("label.zg-b").find('input')[0].checked;// 深圳 - 转户
			if (!sh_kh && !sh_zg && !sz_kh && !sz_zg) {
				khApp.alert("请选择开通账户");
				return;
			}
			stockAccount += " " + (sh_kh ? 1 : (sh_zg ? 1 : "")) + " " + (sz_kh ? 2 : (sz_zg ? 2 : ""));
			APP_account.biztype += " " + (sh_kh ? 1 : (sh_zg ? 2 : "")) + " " + (sz_kh ? 1 : (sz_zg ? 2 : ""));

			var sh_stock = $$("#choose-account-a .item-after").html() == "请选择股东账号" ? " " : $$("#choose-account-a .item-after").html();
			var sz_stock = $$("#choose-account-b .item-after").html() == "请选择股东账号" ? " " : $$("#choose-account-b .item-after").html();
			// 下挂账号个数必须与所选股东账户个数一致， 新开默认为" ", 都不选为""
			sh_stock = (sh_kh ? " " : (sh_zg ? sh_stock : ""));
			sz_stock = (sz_kh ? " " : (sz_zg ? sz_stock : ""));
			APP_account.account_num = (sh_stock == "") ? sz_stock : (sh_stock + "," + sz_stock);

		} else {
			$$("input[name=accountStock]").each(function() {
				if (this.checked) {
					stockAccount = stockAccount + " " + $$(this).val();
					if ($$(this).val() == 2) {
						APP_account.biztype += " " + 2;
					} else {
						APP_account.biztype += " " + 1;
					}
				}
			});

		}
		$$("input[name=accountFund]").each(function() {
			if (this.checked) {
				accountFund = accountFund + " " + $$(this).val();
			}
		});
		APP_account.stockAccount = stockAccount;
		APP_account.fundAccount = accountFund;

		if (APP_account.stockAccount == "" && APP_account.fundAccount == "") {
			khApp.alert("请选择开通账户");
			return;
		}
		khApp.showIndicator();
		nextSubmitResult();
	}

	function nextSubmitResult() {
		simulateSign();// 不用CA
	}

	function reRenderProtocal(check1002, check1003) {
		var l = [];
		if (check1002 && check1003) {
			l = APP_account.protocalList_biz15 || [];
		} else if (check1002 && !check1003) {
			l = APP_account.protocalList_biz1 || [];
		} else if (!check1002 && check1003) {
			l = APP_account.protocalList_biz5 || [];
		}
		var htmlInProtocal = [];
		var htmlInprotocalShowArea = [];
		for (var i = 0; i < l.length; i++) {
			var obj = l[i];
			htmlInProtocal.push("<li data-id=\"" + obj.econtract_id + "\" data-md5=\"" + obj.econtract_md5 + "\"></li>");
			htmlInprotocalShowArea.push("<li><a href=\"template-3.0/protocal.html?econtract_id=" + obj.econtract_id
					+ "\" class=\"item-link item-content protocal-link\">\
						<div class=\"item-inner\">\
								<div class=\"item-title\">" + obj.econtract_name
					+ "</div>\
							</div>\
						</a></li>");
		}
		$$("#protocal").html(htmlInProtocal.join(''));
		$$("#protocalShowArea").html(htmlInprotocalShowArea.join(''));
	}
	// 模拟签名并提交
	function simulateSign() {
		APP_account.signValue = "";
		APP_account.protocalElem = $$("#protocal li");
		APP_account.protocalElemLength = APP_account.protocalElem.length;// 需要签名数量
		for (var i = 0; i < APP_account.protocalElemLength; i++) {
			var obj_temp = $$(APP_account.protocalElem[i]);
			if (APP_account.signValue == "") {
				APP_account.signValue += obj_temp.data("id") + ";" + obj_temp.data("md5") + ";" + obj_temp.data("md5");
			} else {
				APP_account.signValue += "|" + obj_temp.data("id") + ";" + obj_temp.data("md5") + ";" + obj_temp.data("md5");
			}
		}

		khApp.showIndicator();
		$$(".sign-next-button").addClass('disabled');
		$$.ajax({
			url : '/setAccount.do?rnd=' + new Date().getTime(),
			method : "POST",
			timeout : 15000,
			data : {
				"stockAccount" : APP_account.stockAccount,
				"fundAccount" : APP_account.fundAccount,
				"signValue" : APP_account.signValue,
				"cert_sn" : "NOSN",
				"bizOpType" : APP_account.biztype,
				"account_num" : APP_account.account_num,
				"account_page_flag" : APP_account.account_page_flag,
				"userOpenType":appParams.userOpenType|| '1',
				"userSubOpenType":appParams.userSubOpenType|| ''
			},
			success : function(d) {
				khApp.hideIndicator();
				var data = JSON.parse(d);
				if (data.errorNo === 0) {
					CRHloadPage(data.nextPage || '/pwdset');
					stepSync("openStockAccount");
					stepSync("AgreementSign");
				} else {
					$$(".sign-next-button").removeClass('disabled');
					khApp.alert(data.errorInfo);
				}
			},
			error : function() {
				khApp.hideIndicator();
				$$(".sign-next-button").removeClass('disabled');
				khApp.alert(MESSAGE_TIMEOUT);
			},
			timeout : function() {
				khApp.hideIndicator();
				$$(".sign-next-button").removeClass('disabled');
				khApp.alert(MESSAGE_TIMEOUT);
			}
		});
	}
	function init() {
		APP_account.hide_button = $$("#hide_button").val();
		APP_account.biztype_need = $$("#biztype_need").val();
		APP_account.stockAccount = "";
		APP_account.fundAccount = "";
		APP_account.signValue = "";
		APP_account.hasSignSize = 0;
		APP_account.haveFundAccount = false;
		APP_account.haveStockAccount = false;
		khApp.showIndicator();
		$$.ajax({
			url : '/getAccountInfo.do?rnd=' + new Date().getTime(),
			data : {
				"clientOpenType" : appParams.clientOpenType || '1',
				"clientSubOpenType" : appParams.clientSubOpenType || '',
				"userOpenType":appParams.userOpenType|| '1',
				"userSubOpenType":appParams.userSubOpenType|| ''
			},
			type : 'POST',
			success : function(d) {
				var data = JSON.parse(d);
				if (data.errorNo === 0) {
					APP_account.sn = data.sn;
					data.haveFundAccount = false;
					APP_account.protocalList_biz15 = data.protocalList_biz15;
					APP_account.protocalList_biz1 = data.protocalList_biz1;
					APP_account.protocalList_biz5 = data.protocalList_biz5;
					APP_account.checkReviewTime = data.checkReviewTime;
					if (data.fundAccountTypeList && data.fundAccountTypeList.length > 0) {
						data.haveFundAccount = true;
						APP_account.haveFundAccount = true;
					}
					data.haveStockAccount = false;
					if (data.stockAccountTypeList && data.stockAccountTypeList.length > 0) {
						data.haveStockAccount = true;
						APP_account.haveStockAccount = true;
					}
					View.render({
						bindings : APP_account.bindings,
						model : data
					});
					khApp.hideIndicator();
					// 根据设置的账户信息回显页面
					initPageItems(data);
					_CMN.log("accountController init finish");
				}
			}
		});
	}
	return {
		init : init
	};
});