define(['utils', 'GS'], function (Utils, GS) {
  var APP_appropriateResult = {};
  APP_appropriateResult.cert_sn = "";
  APP_appropriateResult.signValue = "";
  var afterBindings = [{
      element: '.goBack',
      event: 'click',
      handler: function () {mainView.loadPage("/openaccount?fnf=returnPass");}
  },{
	  element: 'input[name="agreement"]',
	  event: 'change',
	  handler: agreementClick
  },{
      element: '.risk-next-button',
      event: 'click',
      handler: nextSubmit
  },{
	  element:'.risk-fitlink',event:'click',handler:function(){
		  mainView.loadPage("/template-3.0/protocal.html?econtract_id=" + $$(this).data("id"));
	  }
  }];
  
  var resultList;
  var resultList1;
  var riskResultQuery;
  function init() {
      //判断是否使用CA
      if( appParams.isUseCA == "true"){
          findSn();
      }
    khApp.showIndicator();
    $$.ajax({
      url: '/getRiskSuitProtocal.do?v='+new Date().getTime(),
      type: 'POST',
        data:{
            protocal_flag:"1"
        },
      success: function (d) {
        var data = JSON.parse(d);
        if (data.errorNo == 0) {
            APP_appropriateResult.cert_sn = data.cert_sn;
            resultList = data.resultList;
            resultList1 = data.resultList1;
            riskResultQuery = data.riskResultQuery;
          renderResult({
            model: data,
            bindings: afterBindings
          });
          _CMN.log("appropriateResultController init finish");
        }
        khApp.hideIndicator();
      }
    });
  }

  function agreementClick(event){
      event.stopPropagation();
      setTimeout(function(){
          var isChecked = $$("input[name='agreement']").prop('checked');
          if (isChecked) {
              $$('.button-fill').removeClass('disabled');
          } else {
              $$('.button-fill').addClass('disabled');
          }
      }, 100);
  }

  function nextSubmit() {
	  //判断是否使用CA
      khApp.showIndicator();
      $$(".risk-next-button").addClass("disabled");
      if( appParams.isUseCA == "true"){
          //对协议进行签名
          APP_appropriateResult.protocalElem = resultList;
          APP_appropriateResult.protocalElemLength = APP_appropriateResult.protocalElem.length;//需要签名数量
          if(APP_appropriateResult.protocalElemLength > 0){
              var obj = APP_appropriateResult.protocalElem[0];
              var agreementNo = obj.econtract_id;
              var value = obj.econtract_md5;
              CERT.sign(APP_appropriateResult.sn,value,"protocalSignRiskCallBack");
          }
      }else{
          simulateSign(resultList1, "1"); // 风险揭示
      }
  }

    //签名回调方法
    function protocalSignRiskCallBack(errorNo, errorInfo, signValue) {
        if (errorNo == "-3") {
            $$(".risk-next-button").removeClass("disabled");
            khApp.alert("未找到数字证书，请重新下载数字证书");
            return;
        }
        if (errorNo == "-2") {
            $$(".risk-next-button").removeClass("disabled");
            khApp.alert("开户协议签名出错，请确认是否正确安装数字证书");
            return;
        }
        if (errorNo == "-1") {
            $$(".risk-next-button").removeClass("disabled");
            khApp.alert("数字证书出错，请确认是否正确输入数字证书密码");
            return;
        }
        var protocalElem = resultList;
        var protocalElemLength = protocalElem.length;
        for(var i = 0;i<protocalElemLength; i++){
            var obj_temp = protocalElem[i];
            if(signValue == ""){
                signValue += obj_temp.econtract_id + ";" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5+";";
            }else{
                signValue += "|" + obj_temp.econtract_id + ";" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5+";";
            }
        }
        APP_appropriateResult.hasSignSize++;
        //进行循环签名
        if (APP_appropriateResult.hasSignSize != APP_appropriateResult.protocalElemLength) {
            if (APP_appropriateResult.hasSignSize < APP_appropriateResult.protocalElemLength) {
                var obj = protocalElem[i];
                var value = obj.econtract_md5;
                //签名
                CERT.sign(APP_appropriateResult.cert_sn, value, "protocalSignCallBack");
            }
            return;
        }
        var biz_id = "10086"; // 不匹配业务id
        if(riskResultQuery.suit_flag == "0"){
            biz_id = "10085"; // 匹配协议业务id
        }
        khApp.showIndicator();
        $$.ajax({
            url: '/protocalSign.do?rnd=' + new Date().getTime(),
            type: "POST",
            timeout:15000,
            data:  {
                "signValue"    : signValue,
                "cert_sn"      : APP_appropriateResult.cert_sn,
                "biz_id"       : biz_id
            },
            success: function(d){
                khApp.hideIndicator();
                var data = JSON.parse(d);
                if(data.errorNo === 0){
                    stepSync("Confirmation");
                   CRHloadPage(data.nextPage||"/pwdset");
                }else{
                    khApp.alert(data.errorInfo);
                }
            },
            error: function(){
                $$(".risk-next-button").removeClass("disabled");
                khApp.alert(MESSAGE_TIMEOUT);
            },
            timeout: function(){
                $$(".risk-next-button").removeClass("disabled");
                khApp.alert(MESSAGE_TIMEOUT);
            }
        });
    }
    window.protocalSignRiskCallBack = protocalSignRiskCallBack;

    //模拟签名并提交
    function simulateSign(result_list,biz_type){
        //对协议进行签名
        APP_appropriateResult.signValue = "";
        APP_appropriateResult.protocalElem = result_list;
        APP_appropriateResult.protocalElemLength = APP_appropriateResult.protocalElem.length;//需要签名数量
        for(var i=0; i<APP_appropriateResult.protocalElemLength;i++){
            var obj_temp = APP_appropriateResult.protocalElem[i];
            if(APP_appropriateResult.signValue == ""){
                APP_appropriateResult.signValue += obj_temp.econtract_id + ";" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5;
            }else{
                APP_appropriateResult.signValue += "|" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5;
            }
        }
        
        if(biz_type == "1") {
        	biz_id = "10087"; //风险揭示
        } else {
        	biz_id = "10085"; //适当性匹配
        	if(riskResultQuery.suit_flag != "0"){
            	biz_id = "10086"; // 不匹配业务id
            }
        }
        
        khApp.showIndicator();
        $$.ajax({
            url: '/protocalSign.do?rnd=' + new Date().getTime(),
            method: "POST",
            timeout:15000,
            data:  {
                "signValue"    : APP_appropriateResult.signValue,
                "cert_sn"      : "NOSN",
                "biz_id"       : biz_id
            },
            success: function(d){
                khApp.hideIndicator();
                var data = JSON.parse(d);
                if(data.errorNo === 0){
                	if(biz_type == "1") {
                		stepSync("Riskbook");
                		simulateSign(resultList, "2"); // 签适当性协议
                	} else {
                		stepSync("Confirmation");
                		CRHloadPage(data.nextPage||"/pwdset");
                	}
                }else{
                    khApp.alert(data.errorInfo);
                }
            },
            error: function(){
                khApp.hideIndicator();
                $$(".risk-next-button").removeClass("disabled");
                khApp.alert(MESSAGE_TIMEOUT);
            },
            timeout: function(){
                khApp.hideIndicator();
                $$(".risk-next-button").removeClass("disabled");
                khApp.alert(MESSAGE_TIMEOUT);
            }
        });
    }


  function renderResult(params) {
    var template = $$('#riskFittemplate').html();
    var compiledTemplate = Template7.compile(template);
    var renderTemplate = compiledTemplate({model: params,SERVICE_DOMAIN_URL:SERVICE_DOMAIN_URL||""});

    $$('#riskFitContent').html(renderTemplate);

    Utils.bindEvents(params.bindings);


  }


  return {
    init: init
  };
});
