define(['views/collectView', 'GS'], function (View, GS) {

	var APP_collect = {};
	APP_collect.pre = "";
	APP_collect.next = "/userprofile";
	APP_collect.cookie = "";
	APP_collect.isRetake = "";
	APP_collect.econtractId = "";
	APP_collect.frontPicUploaded = "0";
	APP_collect.backPicUploaded = "0";
	APP_collect.faceUploaded	="0";
	APP_collect.facePic = "0";
	APP_collect.signValue = "";
	var bindings = [{
		element: '.collect-next-button',
		event: 'click',
		handler: nextSubmit
	}, {
		element: '#cardFront',
		event: 'click',
		handler: uploadFront
	}, {
		element: '#cardBack',
		event: 'click',
		handler: uploadBack
	}, {
		element: '#face',
		event: 'click',
		handler: uploadFacePic
	}, {
        element: '#protocalLink',
        event: 'click',
        handler: displayProtocal
    },{
        element: '#revenueEcontract',
        event: 'click',
        handler: function () {
            // 展示协议内容页
            mainView.loadPage('/template-3.0/protocal.html?econtract_id='+$$(this).data("id"));
        }
    },{
        element: 'input[name=revenue]',
        event: 'change',
        handler: submitRevenue
    }];

	function init() {
		View.init({
			bindings: bindings
		});
		
		APP_collect.frontPicUploaded = "0";
		APP_collect.backPicUploaded = "0";
		APP_collect.faceUploaded	="0";
		APP_collect.signValue = "";
		
		// ajax 取协议id
		reqProtocalId();
		 
		 window.parsePicUrl = parsePicUrl;
	}

    // 展示协议内容页
    function displayProtocal() {
        mainView.loadPage('/template-3.0/protocal.html?econtract_id='+APP_collect.econtractId);
    }

	//取协议内容
	function reqProtocalId() {
		$$.ajax({
			url: '/reqProtocalId.do?rnd=' + new Date().getTime(),
			type: 'GET',
			timeout: 15000, //超时时间设置，单位毫秒
			success: function (data) {
				data = JSON.parse(data);
				if (data.errorNo === 0) {
					APP_collect.cookie = data.model.cookiestr;
					APP_collect.econtractId = data.model.econtractId;
					APP_collect.facePic = data.model.facePic;
					APP_collect.cookie = data.model.cookiestr;
					
					var src = data.model.src;
					var rectification = data.model.rectification;
					if(rectification !="0" && src != "0"){
						View.render({
							model: data.model,
							bindings: bindings
						});				
						var frontType = data.model.frontType;
						var frontSrc = data.model.frontSrc;
						
						var backType = data.model.backType;
						var backSrc = data.model.backSrc;

						var faceType = data.model.faceType;
						var faceSrc = data.model.faceSrc;
						if(frontType == "front"){
							View.showPhotoFront(frontSrc);
							APP_collect.frontPicUploaded = "1";
						}
						if(backType == "back"){
							View.showPhotoBack(backSrc);
							APP_collect.backPicUploaded = "1";
						}
						if(faceType == "face"){
							if(faceSrc != "data:image/.jpg;base64,"){
								View.showPhotoFace(faceSrc);
							}
							APP_collect.faceUploaded = "1";
						}
						
						APP_collect.name = data.model.name;
						APP_collect.code = data.model.code;
						APP_collect.ceraddr  = data.model.ceraddr;
						APP_collect.issued_depart = data.model.issued_depart;
						APP_collect.id_begindate = data.model.id_begindate;
						APP_collect.id_enddate = data.model.id_enddate;
//						if(APP_collect.id_enddate == "3000-12-31"){
//							effect();
//						}
//						changestatus(0);
//						changestatus(1);
						
					}else{
						View.render({
							model: data.model,
							bindings: bindings
						});	
					}
					
				} else {
					khApp.alert(data.errorInfo);
				}
			},
			error: function(){
				khApp.alert(MESSAGE_TIMEOUT);
			},
			timeout: function(){
				khApp.alert(MESSAGE_TIMEOUT);
			}
		});
	}

	/**
	 * 原版本方法
	 * @param  {Number} picType 0: 正面照, 1: 反面照,  2: 
	 */
	function uploadSelect(picType) {
	   if (browser.versions.YiXin) {
	        var params = {type:"camera", width:800, height:600, quality:90};
            YixinJSBridge.invoke("pickImage",  params,  function(result){
                if (result.data) {
                   uploadImage(picType,  result.data);
                }
            } , null);
            return;
        }
	   var picTypeStr;
		switch(picType){
			case 0:
				picTypeStr = "front";
	  			break;
			case 1:
				picTypeStr = "back";
	  			break;
	  		case 2:
	  			picTypeStr = "face";
	  			break;
			default:
				picTypeStr = "front";
		}
		if(browser.versions.ios){	//iphone
			window.location.href="objc://takePictures/?"+picTypeStr+"?"+APP_collect.cookie;
		}else{
			window.jtoJHandle.takePictures(picType,APP_collect.cookie,picTypeStr);
		}
	}

	function uploadFront() {
		uploadSelect(0);
	}
	function uploadBack() {
		uploadSelect(1);
	}
	function uploadFacePic() {
		uploadSelect(2);
	}
	//上传图片到服务器
    function uploadImage(type, image_data) {
        var picType = "front";
        if(type==1) {
            picType = "back";
        }else if (type == 2) {
            picType = "face";
        }
        //BASE64处理'+'
        var data_str=encodeURI(image_data).replace(/\+/g,'%2B');
        //khApp.alert("uploadImage-> data: " + image_data.substr(58,10) + "|" + image_data.substr(420,15)+ "|" + image_data.substr(1460,10)+ "|" + image_data.substr(1888,10));
        $$.ajax({
            url: "/uploadBase64Pic.do",
            type: "POST",
            data: {picType:picType, base64File:data_str,uploadFileType:".jpg",uploadFileName:picType+".jpg"},
            success: function(res){
                khApp.showIndicator();
                parsePicUrl(res);
                khApp.hideIndicator();
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                khApp.alert("上传图片失败:"+textStaus);
            }
          });
    }
	/**
	 * 上传照片类型
	 * @param  {Number} type 0: 正面照, 1: 反面照, 2: 大头照
	 */
	function uploadStart(type) {
		var typeText = ['正面照', '反面照', '大头照'][type];

		khApp.modal({
			title: '上传' + typeText,
			buttons: [{
				text: '拍照',
				onClick: function () {
					// khApp.alert('您选择了拍照');
					selectPic('c', type, APP_collect.cookie);
				}
			}, {
				text: '浏览相册',
				onClick: function () {
					//khApp.alert('您选择了浏览相册');
					selectPic('p', type, APP_collect.cookie);
				}
			}, {
				text: '取消'
			}]
		});
	}

	/**
	 * 调用原生方法
	 * @param  {String} picSrc 'c': 拍照, 'p': 相册
	 * @param  {Number} picType 0: 正面照, 1: 反面照, 2: 大头照
	 * @param  {String} cookie
	 */
	function selectPic(picSrc, picType, cookie) {
		if (browser.versions.ios) { // iphone
			var picTypeStr = "front";
			if(picType === 1) picTypeStr = "back";
			window.location.href = "objc://selectPicture/?" + picSrc + "?" + picTypeStr + "?" + cookie;
		} else {
			window.jtoJHandle.takePictures(picSrc,picType,cookie);
		}
	}

	/**
	* 解析图片 url
	* @param  {Object} json
	*/
	function parsePicUrl(json){
		var obj = eval('(' + json + ')');
		var errNo = obj.errorNo;
		if (errNo === 0) {
			//解析返回的图片地址url
			var picType = obj.picType;
			var url = obj.src;
			//khApp.alert("image: " + url);
			switch(picType){
				case 'front':
					View.showPhotoFront(url);
					appParams.frontUrl = url;
					APP_collect.frontPicUploaded = "1";
					break;
				case 'back':
					View.showPhotoBack(url);
					appParams.backUrl = url;
					APP_collect.backPicUploaded = "1";
					break;
				case 'face':
					View.showPhotoFace(url);
					appParams.faceUrl = url;
					APP_collect.faceUploaded	= "1";
					break;
				default:
			}
		} else {
			khApp.alert(obj.errorInfo);
		}
	}
	window.parsePicUrl = parsePicUrl;


    function submitRevenue() {
        if(!$$("input[name=revenue]")[0].checked){
            khApp.modal({
                title:  '开户提示',
                text: '<div style="text-align:left;color:#4d4d4d">非中国税收居民无法进行网上开户，请您前往就近营业部开户</div>',
                buttons: [
                    {
                        text: '我知道了',
                        onClick: function () {
                        	khApp.closeModal();
                        }
                    }
                ]
            });
        }
    }

    var Monitor = {
		status:0,//0:未监控;1:监控中
		actList:[],//action List
		addAct:function(action){
			this.actList.push(action);
			action.setMonitor(this);
		},
		runAct:function(conf){
			this.conf = conf;
			for(var i=0;i<this.actList.length;i++){
				var checkFunc = this.actList[i].check;
				if(typeof(checkFunc)=='function'){
					var errorInfo = checkFunc();
					if(errorInfo){
						this.conf.failCheck(errorInfo);
						return;
					}
				}
			}
			this.conf.finishCheck();
			for(var i=0;i<this.actList.length;i++){
				this.actList[i].run();
			}
			this.status=1;
		},
		checkResult:function(){
			if(this.status===1){
				var succN = 0;
				for(var i=0;i<this.actList.length;i++){
					var s = this.actList[i].status;
    				if(s==1){
    					succN++;
    				}else if(s==2){
    					this.status=0;
    					this.conf.fail(this.actList[i].errorInfo);
    					return;
    				}
    			}
				if(succN ==this.actList.length){
					this.status=0;
					this.conf.success();
				}
			}
		}
    };
    var Action = function(conf){
    	this.run = conf.run;//行动执行
    	this.check = conf.check;//行动检查
    	this.monitor;//行动监控
    };
    Action.prototype={
		status:-1,
		errorInfo:"",
		setMonitor:function(monitor){
			this.monitor = monitor;
		},
		finish:function(status,errorInfo){
			this.status = status;
			this.errorInfo = errorInfo||'';
			this.monitor.checkResult();
		}
    };
    
    
    
    Monitor.addAct(new Action({"check":function(){
    	if(!$$("input[name=revenue]")[0].checked){
    		return "非中国税收居民无法进行网上开户，请您前往就近营业部开户";
        }
    	if(APP_collect.frontPicUploaded === "0"){
    		return "请上传身份证正面照片";
		}
		if(APP_collect.backPicUploaded === "0"){
			return "请上传身份证反面照片";
		}
		if(APP_collect.facePic == "1"){
			if(APP_collect.faceUploaded === "0"){
				return "请上传大头照";
			}
		}
		return "";
    },"run":function(){
    	var THIS = this;
    	THIS.status = 0;
    	$$.ajax({
			url: '/photoSubmit.do?rnd=' + new Date().getTime(),
			type: 'POST',
			data: {"isOld":1},
			timeout: 15000,
			success: function (data1) {
				data = JSON.parse(data1);
				if (data.errorNo === 0) {
					THIS.finish(1);
				} else {
					THIS.finish(2,data.errorInfo);
				}
			},
			error: function() {
				THIS.finish(2,MESSAGE_TIMEOUT);
	   		},
	   		timeout: function() {
	   			THIS.finish(2,MESSAGE_TIMEOUT);
	   		}
		});
    }}));
    
    Monitor.addAct(new Action({"run":function(){
    	var THIS = this;
    	THIS.status = 0;
    	$$.ajax({
            url: '/profileRevenue/commitUserProfileRevenue.do?rnd=' + new Date().getTime(),
            method:"POST",
            timeout:15000,
            data:{revenue_inmate_type: "1"},
            success: function(data1){
                var data = JSON.parse(data1);
                var status = data.errorNo===0?1:2;
                THIS.finish(status,data.errorInfo);
            },
            error: function(){
            	THIS.finish(2,MESSAGE_TIMEOUT);
            },
            timeout: function(){
            	THIS.finish(2,MESSAGE_TIMEOUT);
            }
        });
    }}));
    
    Monitor.addAct(new Action({"run":function(){
    	var THIS = this;
    	THIS.status = 0;
    	APP_collect.protocalElem = $$(".agree-block a");
        APP_collect.protocalElemLength = APP_collect.protocalElem.length;//需要签名数量
        for(var i=0; i<APP_collect.protocalElemLength;i++){
            var obj_temp = $$(APP_collect.protocalElem[i]);
            if(APP_collect.signValue == ""){
                APP_collect.signValue += obj_temp.data("id") + ";" + obj_temp.data("md5") + ";" + obj_temp.data("md5");
            }else{
                APP_collect.signValue += "|" + obj_temp.data("id") + ";" + obj_temp.data("md5") + ";" + obj_temp.data("md5");
            }
        }
        $$.ajax({
            url: '/protocalSign.do?rnd=' + new Date().getTime(),
            method: "POST",
            timeout:15000,
            data:  {
                "signValue"    : APP_collect.signValue,
                "cert_sn"      : "NOSN",
				"biz_id"       : "22123"
            },
            success: function(data1){
                var data = JSON.parse(data1);
                var status = data.errorNo===0?1:2;
                THIS.finish(status,data.errorInfo);
            },
            error: function(){
            	THIS.finish(2,MESSAGE_TIMEOUT);
            },
            timeout: function(){
            	THIS.finish(2,MESSAGE_TIMEOUT);
            }
        });
    }}));
    
    
	function nextSubmit() {
		Monitor.runAct({
    		failCheck:function(errorInfo){
    			khApp.alert(errorInfo);
    		},
    		finishCheck:function(){
    			khApp.showIndicator();
    			$$(".collect-next-button").addClass('disabled');
    		},
			success:function(){
				khApp.hideIndicator();
				CRHloadPage(APP_collect.next);
        		khApp.closeModal();
			},
			fail:function(errorInfo){
				khApp.hideIndicator();
				$$(".collect-next-button").removeClass('disabled');
				khApp.alert(errorInfo);
			}
		});
	}

	return {
		init: init
	};
});
