define(['views/departmentView', 'GS'], function (View, GS) {

	var APP_branch = {};
	APP_branch.branchInfo = {};
	APP_branch.pre = "/returnPhoto.do";
	APP_branch.branchNo = "";
	APP_branch.tempBranchNo = "";
	APP_branch.referMobile = "";
	APP_branch.next = "/userprofile";
	APP_branch.branchName = "";
	APP_branch.refererName = "";
	APP_branch.brokerCode = "";
	APP_branch.defaultBranchNo = "";
	APP_branch.channelId = "";
	
	var bindings = [{
		element: '.department-next-button',
		event: 'click',
		handler: nextSubmit
	}, {
		element: '.nearby-link',
		event: 'click',
		handler: selectFromNearby
	}, {
		element: '.all-link',
		event: 'click',
		handler: selectFromAll
	}, {
		element: '.department-name',
		event: 'click',
		handler: selectFromChannel
	},{
		element: '#departmentGoBack',
		event: 'click',
		handler: goBack
	}];

	var afterBindings = [{
		element: '[name=nearby]',
		event: 'change',
		handler: selectedName
	}, {
		element: '[name=all]',
		event: 'change',
		handler: selectedName
	}];
	function init() {

		View.render({
			bindings: bindings
		});
		//显示要填写的推荐人信息项
		showRefereeInfo();
		//获取营业部信息
		getDepartInfo();
		
		$$('.department-name').find('h2').text(APP_branch.branchName);
		
		if(APP_branch.channelId ==""){
			if (browser.versions.ios) { // iphone
				window.location.href = "objc://nearbyBranch/?laodRecDepartment";
			} else {
				window.jtoJHandle.location('laodRecDepartment');
			}
		}
//		startUpdatingLocation();
	}
	
	function getDepartInfo(){
		APP_branch.branchName = null == $$("#branchName").val() ? "" : $$("#branchName").val();
		APP_branch.branchNo = null == $$("#branchNo").val() ? "" : $$("#branchNo").val();
		APP_branch.refererName = null == $$("#refererName").val() ? "" : $$("#refererName").val();
		APP_branch.referMobile = null == $$("#brokerMobile").val() ? "" : $$("#brokerMobile").val();
		APP_branch.brokerCode = null == $$("#brokerCode").val() ? "" : $$("#brokerCode").val();
		APP_branch.defaultBranchNo = null == $$("#defaultBranchNo").val() ? "" : $$("#defaultBranchNo").val();
		APP_branch.channelId = null== $$("#channelId").val() ? "" : $$("#channelId").val();
		if(APP_branch.channelId){
			if(($$.trim(APP_branch.branchName).indexOf('请选择营业部>') >= 0)){
				$$('.department-badge').html('您选择的是');
				$$("#branch").hide();
				if(APP_branch.refererName!=null){
					$$("input[name=recName]").val(APP_branch.refererName);
					$$("input[name=recName]").attr("readOnly",true);
				}
				if(APP_branch.referMobile!=null){
					$$('input[name=recphone]').val(APP_branch.referMobile);
					$$("input[name=recphone]").attr("readOnly",true);
				}
				if(APP_branch.brokerCode!=null){
					$$("input[name=brokerCode]").val(APP_branch.brokerCode); 
					$$("input[name=brokerCode]").attr("readOnly",true);
				}
				if(($$.trim(APP_branch.branchName).indexOf('请选择营业部>') != 0)){
					$$(".department-name").off('click',selectFromChannel);
				}
			}
		}else{
			$$('.department-badge').html('您选择的是');
		}
		
		if(APP_branch.channelId  && ($$.trim(APP_branch.branchName).indexOf('请选择营业部>') >= 0) ){
			$$("input[name=brokerCode]").val(APP_branch.brokerCode); 
			$$("input[name=recName]").val(APP_branch.refererName);
			$$('input[name=recphone]').val(APP_branch.referMobile);
			document.getElementById("brokerCode").disabled=true;
		}else{
			if(APP_branch.branchNo != APP_branch.defaultBranchNo){
				$$('.department-badge').html('您选择的是');
				$$("input[name=brokerCode]").val(APP_branch.brokerCode);
				$$("input[name=recName]").val(APP_branch.refererName);
				$$('input[name=recphone]').val(APP_branch.referMobile);
			}else{
				if(APP_branch.brokerCode != ""){
					$$("input[name=brokerCode]").val(APP_branch.brokerCode);
					$$("input[name=recName]").val(APP_branch.refererName);
					$$('input[name=recphone]').val(APP_branch.referMobile);
				}
			}
		}
	}
	//选择显示推荐人信息
	function showRefereeInfo(){
		var params = {};
		params.showRecName = "true" == $$("#showRecName").val() ? true : false;
		params.showRecPhone = "true" == $$("#showRecPhone").val() ? true : false;
		params.showBrokerCode = "true" == $$("#showBrokerCode").val() ? true : false;
		if(params.showRecName || params.showRecPhone || params.showBrokerCode ){
			$$("#refereeIndicator").show();
		}else{
			$$("#recMesssages").hide();
		}
		View.refereeInfo({
			attrs: params
		});
	}
	//启动定位
	function startUpdatingLocation(){
		if (browser.versions.ios) { // iphone
			window.location.href = "objc://startUpdatingLocation/";
		} else {
			
		}
	}
	
	//停止定位
	function stopUpdatingLocation(){
		if (browser.versions.ios) { // iphone
			window.location.href = "objc://stopUpdatingLocation/";
		} else {
			
		}
	}

	//查询已选的营业部（1）或者附近的营业部（2）或者推荐营业部（0）
	function laodRecDepartment(pst, province, city) {
		khApp.showIndicator();
		$$.ajax({
			url: '/nearBranch.do?rnd=' + new Date().getTime(),
			type: 'POST',
			data: {
				"position": pst, 
				"province":encodeURI(encodeURI(province)),
				"city":encodeURI(encodeURI(city))
				},
			success: function (data) {
				khApp.hideIndicator();
				data = JSON.parse(data);
				if (data.errorNo === 0) {
					APP_branch.branchNo = data.branchNo;
					APP_branch.tempBranchNo = data.branchNo;
					APP_branch.referMobile = data.referMobile;
					APP_branch.refererName = data.refererName;
					$$('input[name=recphone]').val(APP_branch.referMobile);
					$$('input[name=recName]').val(APP_branch.refererName);
					$$('input[name=brokerCode]').val(APP_branch.brokerCode);
					APP_branch.branchInfo = data;
					View.renderName(data.branchName);
					
					switch(data.dataType) {
					case '0':
						View.renderBadge('default');
						  break;
					case '1':
						View.renderBadge('selected');
					  break;
					case '2':
						View.renderBadge('nearby');
					  break;
					}
				}else {
					$$('.department-name').find('h2').text(data.errorInfo);
					$$('.department-badge').html('');
				}
			},
			error: function() {
				khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		},
	   		timeout: function() {
	   			khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		}
		});
	}
	window.laodRecDepartment = laodRecDepartment;

	function selectFromNearby() {
		if (browser.versions.ios) { // iphone
			window.location.href = "objc://nearbyBranch/";
		} else {
			window.jtoJHandle.location();
		}
	}
	
	function selectNearby(pst) {
		startSelect('nearbySelect', '/nearbyBranch.do?rnd=' + new Date().getTime(), pst);
	}
	window.selectNearby = selectNearby;
	
	function selectFromChannel(){
//		if(APP_branch.branchNo){
//			selectFromAll();
//		}
		startSelect('nearbySelect', '/channelBranch.do?rnd=' + new Date().getTime(), "");
	}
	function selectFromAll() {
		$$('.department-badge').html('您选择的是');
		startSelect('allSelect', '/listBranch.do?rnd=' + new Date().getTime(), "");
	}

	function startSelect(id, url, pst) {
		var isSelectLocal = $$('#' + id)[0];
		if (isSelectLocal) {
			openSelect(id);
		} else {
			remoteSelect(id, url, pst);
		}
	}

	function remoteSelect(id, url, pst) {
		var _id = id;
		khApp.showIndicator();
		$$.ajax({
			url: url,
			type: 'POST',
			data: {"position": pst},
			success: function (data) {
				data = JSON.parse(data);
				khApp.hideIndicator();
				if (data.errorNo === 0) {
					var model = data.model;
					View.render({
						bindings: bindings,
						model: model
					});
					View.renderSelect({
						bindings: afterBindings,
						model: data.model
					});
					openSelect(_id);
				}else {
					khApp.alert(data.errorInfo);
				}
			},
			error: function() {
				khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		},
	   		timeout: function() {
	   			khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		}
		});
	}
	
	function listAllBranch() {
		khApp.showIndicator();
		$$.ajax({
			url: '/listBranch.do?rnd=' + new Date().getTime(),
			type: 'POST',
			success: function (data) {
				khApp.hideIndicator();
				data = JSON.parse(data);
				if (data.errorNo === 0) {
					var model = data.model;
					View.render({
						bindings: bindings,
						model: model
					});
				}else {
					khApp.alert(data.errorInfo);
				}
			},
			error: function() {
				khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		},
	   		timeout: function() {
	   			khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		}
		});
	}

	function openSelect(id) {
		khApp.smartSelectOpen('#' + id);
	}

	function selectedName() {
		APP_branch.branchNo = this.options[this.selectedIndex].value;
		console.log(this.options[this.selectedIndex].value);
		var selectedText = this.options[this.selectedIndex].text;
		View.renderName(selectedText);
		View.renderBadge();
	}

	function nextSubmit() {
		if(!APP_branch.branchNo || APP_branch.branchName==""){
			khApp.alert("请选择营业部！");
        	return;
		}
		//推荐人手机号
		var recphone = $$("input[name=recphone]").val();
		if (recphone && !isMobile(recphone)) {
			khApp.alert('手机号码有误，请重新输入');
			return;
		}
		if(APP_branch.referMobile != "" && recphone == null){
			recphone = APP_branch.referMobile;
		}
		//推荐人姓名
		var recName = $$("input[name=recName]").val();
		
		if(APP_branch.refererName != "" && recName == null){
			recName = APP_branch.refererName;
		}
		//推荐人编号
		var brokerCode = $$("input[name=brokerCode]").val();
		if(APP_branch.brokerCode != "" && brokerCode == null){
			brokerCode = APP_branch.brokerCode;
		}
		stopUpdatingLocation();
		$$(window).off('resize', window.bind_resize);
		mainView.loadPage(APP_branch.next+ "/?branchNo=" + APP_branch.branchNo + "&recphone=" + recphone + "&recName=" + recName + "&brokerCode=" + brokerCode);
	}
	//返回
	function goBack() {
		mainView.loadPage(APP_branch.pre);
	}
	
	function isMobile(str) {
		var reg = /^[1][34578]\d{9}$/;
		return reg.test(str);
	}

	return {
		init: init
	};
});
