define([ 'views/depositoryView', 'GS', 'utils' ], function(View, GS, Utils) {

	var APP_thirdBank = {};
	APP_thirdBank.pre = "/returnUserProfile.do";
	APP_thirdBank.next = "/exam";
	APP_thirdBank.isReBind = "";// 0:绑定 1：重新绑定
	APP_thirdBank.Bank = "";
	APP_thirdBank.BankCode = "";
	APP_thirdBank.econtractId = "";
	APP_thirdBank.bankType = "";
	APP_thirdBank.needShowActivity = "";// 1:展示 0：不展示

	APP_thirdBank.accountNo = "";
	APP_thirdBank.accountPass = "";

	APP_thirdBank.deposityBankListNew = [];
	APP_thirdBank.username = "";
	APP_thirdBank.cardType = "";// 借记卡,贷记卡
	APP_thirdBank.scanCardNo = "";// 确认页面的银行卡号

	APP_thirdBank.dict_prompt = "";
	APP_thirdBank.sn = "";
	APP_thirdBank.md5 = "";

	APP_thirdBank.Bindings = [ {
		element : '#depositoryGoBack',
		event : 'click',
		handler : goBack
	}, {
		element : '.take-photos',
		event : 'click',
		handler : getBankIDScan
	}, {
		element : 'input[name="cardNo"]',
		event : 'keyup',
		handler : cardInput
	}, {
		element : '.depository-next-button',
		event : 'click',
		handler : nextSubmit
	}, {
		element : '#bank',
		event : 'change',
		handler : selectBank
	}, {
		element : '#protocalLink',
		event : 'click',
		handler : function() {
			mainView.loadPage('/template-3.0/protocal.html?econtract_id=' + APP_thirdBank.econtractId);
		}
	}, {
		element : '.item-input input',
		event : 'input',
		handler : inputChange
	}, {
		element : 'input[name=agreement]',
		event : 'change',
		handler : setNextBtn
	}, {
		element : '.depoconfirm-next-button',
		event : 'click',
		handler : confirmBankCardNo
	}, {
		element : '.depo-supportbank',
		event : 'click',
		handler : supportBankShow
	}, {
		element : '.bank-list-picker .right',
		event : 'click',
		handler : supportBankHide
	} ];
	function goBack() {
		if($$(".depo-banknum-confirm").data("isshow")=="1"){
			$$(".depo-details").show();
			$$(".depo-banknum-confirm").hide().data("isshow", "0");
			setLeftBtn();
		}else{
			CRHloadPage(APP_thirdBank.pre);
		}
	}
	function setInVaildCardNo(v) {
		v = v.replace(/\s/g, '');
		if (v) {
			appParams.inVaildCardNo = appParams.inVaildCardNo || {};
			appParams.inVaildCardNo[v] = '1';
		}
	}
	/**
	 * 扫描银行卡
	 */
	function getBankIDScan() {
		try {
			if (browser.versions.ios) {
				CRHClientbBrowser.loadObjURL("objc://getBankIDScan/?scanBankCardCallBack?jsonStr?" + APP_thirdBank.username);
			} else {
				window.jtoJHandle.getBankIDScan(APP_thirdBank.username, "scanBankCardCallBack");
			}
			_CMN.log("depositoryNewController.getBankIDScan");
		} catch (e) {
			_CMN.log("depositoryNewController.getBankIDScan error[" + (e.stack || e.message || '') + "]");
		}

	}
	/**
	 * 扫描银行卡回调 银行卡确认页面信息显示
	 */
	function scanBankCardCallBack(d) {
		try {
			_CMN.log("depositoryNewController.scanBankCardCallBack d[" + (function(j) {
				var a = JSON.parse(j);
				if (a.base64Image) {
					a.base64Image = '...';
				}
				return JSON.stringify(a);
			})(d) + "]");
			var json = JSON.parse(d);
			var url = decodeURIComponent(json.base64Image);
			url = "data:image/.jpg;base64," + url;
			$$('#banknum_screenshot').attr("src", url);
			var cardNums = json.cardNum.replace(/[\s]/g, '').replace(/(\d{4})(?=\d)/g, "$1 ");
			$$(".depo-banknum-nums .depo-cardids").val(cardNums);
			$$("#depo-banknum-name").val(json.bankName);
			$$(".depo-details").hide();
			$$(".depo-banknum-confirm").show().data("isshow", "1");
			APP_thirdBank.cardType = json.cardType;
			if (json.cardType && (json.cardType.indexOf('贷记卡') > -1 || json.cardType.indexOf('信用卡') > -1)) {
				setInVaildCardNo(cardNums);
			}
			setLeftBtn();
		} catch (e) {
			_CMN.log("depositoryNewController.scanBankCardCallBack error[" + (e.stack || e.message || '') + "]");
		}
	}
	/**
	 * 银行卡确定
	 */
	function confirmBankCardNo() {
		$$(".depo-details").show();
		$$(".depo-banknum-confirm").hide().data("isshow", "0");
		var account_no = $$(".depo-banknum-nums .depo-cardids").val();
		var bank_name = $$("#depo-banknum-name").val();
		$$("input[name=cardNo]").val(account_no);
		getBankSelectByBankName(bank_name, account_no,"AT");
		setScanBankCardBtn();
		setNextBtn();
		setLeftBtn();
	}
	function inputChange() {
		setNextBtn();
	}
	function setScanBankCardBtn() {
		if (appParams.clientFlag == "1") {
			var f = $$("input[name=cardNo]").val().replace(/\s/g, '');
			if (f) {
				$$(".take-photos").hide();
			} else {
				$$(".take-photos").show();
			}
		}
	}
	function setNextBtn(func) {
		setTimeout(function() {
			if (APP_thirdBank.todayrebind_trylimit == "0" && APP_thirdBank.isReBind == "1") {
				$$('.depository-next-button').addClass('disabled');
				return;
			}
			if (!$$("input[name=agreement]")[0].checked) {
				$$('.depository-next-button').addClass('disabled');
				return;
			}
			var inputList = $$('.item-input input');
			for (var i = 0; i < inputList.length; i++) {
				var inputItem = inputList[i];
				if ($$(inputItem).val() == '' && $$(inputItem).parent().parent().parent().parent().css("display") != "none") {
					if ((APP_thirdBank.bankType != '' && APP_thirdBank.bankType != '22') || inputItem.name != 'cardNo') {// 22卡号可输可不输
						$$('.depository-next-button').addClass('disabled');
						return false;
					}
				}
			}
			$$('.depository-next-button').removeClass('disabled');
			if(typeof(func)=='function'){func();}
		}, func?1:500);
	}
	function cardInput() {
		this.value = this.value.replace(/[\s]/g, '').replace(/(\d{4})(?=\d)/g, "$1 ");
		setScanBankCardBtn();
	}
	function resetSelect() {
		$$('.smart-select select').each(function() {
			this.selectedIndex = -1;
		});
	}
	function render(params) {
		var template = $$('#depositoryTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({
			bankPage : params.model,
			SERVICE_DOMAIN_URL : SERVICE_DOMAIN_URL || ""
		});

		$$('#depositoryContent').html(renderTemplate);
		Utils.bindEvents(params.bindings);
		resetSelect();
	}
	function renderBank(params) {
		var template = $$('#bankListTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({
			bankPage : params.model.bankIconList
		});
		$$('.bank-list-picker .picker-modal-inner').html(renderTemplate);
		Utils.bindEvents(params.bindings);
	}

	function unique(arr) {
		var len = arr.length;
		var result = [];
		for (var i = 0; i < len; i++) {
			if (result.length > 0) {
				var flag = false;
				for (var j = 0; j < result.length; j++) {
					if (arr[i].pinyin == result[j].pinyin) {
						flag = true;
						break;
					}
				}
				if (!flag) {
					result.push(arr[i]);
				}
			} else {
				result.push(arr[i]);
			}
		}
		return result;
	}
	function deepCopy(obj) {
		if (typeof obj != 'object') {
			return obj;
		}
		var newobj = {};
		for ( var attr in obj) {
			newobj[attr] = deepCopy(obj[attr]);
		}
		return newobj;
	}
	function initDepositoryInfo(data) {
		var account_no = "";
		if(data.model.account_no){
			account_no = data.model.account_no.replace(/[\s]/g, '').replace(/(\d{4})(?=\d)/g, "$1 ");
			$$("input[name=cardNo]").val(account_no);
		}
		if (data.model.bank_no&&data.model.bank_name) {
			getBankSelectByBankName(data.model.bank_name,account_no,'INIT');
		}
		if (data.model.bank_pwd && data.model.bank_pwd != " ") {
			$$("input[name=cardPSW]").val(data.model.bank_pwd);
		}
		setNextBtn();
	}

	function getBankSelectByBankName(bank_name, account_no,_type_) {
		if(bank_name){
			var tmp = /中国((建设|农业|工商|光大|民生|邮政储蓄|邮储)银行)/.exec(bank_name);
			if(tmp&&tmp.length==3){
				bank_name = tmp[1];
			}
			bank_name = bank_name.replace("广东发展","广发").replace("邮政储蓄","邮储").replace("上海浦东发展","浦发").replace("浦东发展","浦发").replace("上海浦发","浦发");
			var count = 0;
			for (var i = 0; i < APP_thirdBank.deposityBankListNew.length; i++) {
				var bank = APP_thirdBank.deposityBankListNew[i];
				var bankName = bank.bank_name.replace("银行", "").replace("存管", "");
				if (bank_name.indexOf(bankName) > -1) {
					APP_thirdBank.BankCode = bank.res_bank_no;
					APP_thirdBank.Bank = bank.bank_name;
					APP_thirdBank.bankType = bank.bankType;
					APP_thirdBank.dict_prompt = bank.dict_prompt;
					if (bank.depository_memo && bank.depository_memo != " ") {
						$$(".warn-prompt-top .text").html(bank.depository_memo);
						$$(".warn-prompt-top").show();
					} else {
						$$(".warn-prompt-top").hide();
					}
					$$("#bankTxt").html(APP_thirdBank.Bank + "（" + APP_thirdBank.dict_prompt + "）").css("color", "#333");
					selectBankType(APP_thirdBank.bankType);
					setActivityArea(APP_thirdBank.BankCode);
					_CMN.log("selectBank["+_type_+"][Bank="+APP_thirdBank.Bank+"][BankCode="+APP_thirdBank.BankCode+"][bankType="+APP_thirdBank.bankType+"]");
					if (bank.econtract_name) {
						$$("#protocalLink").html("《<span id='bankName'></span>" + bank.econtract_name + "》");
					} else {
						$$("#protocalLink").html("《<span id='bankName'></span>" + APP_thirdBank.Bank + "》三方协议");
					}
//					$$("#sjyh_name").html(bankName + "银行");
					APP_thirdBank.econtractId = bank.econtract_id;
//					$$(".depo-banktip").show();
					$$(".content-block-title").show();
					count++;
					// 有账号为一步式， 否则需要为两步式需要匹配两次银行名称取得。
					if ((account_no && account_no != "") || count == 2) {
						break;
					}
				}
			}
		}
	}

	function selectBank() {
		$$("#bankTxt").css("color", "#333");
		var selectedOption = this.options[this.selectedIndex], type = $$(selectedOption).data('type'), text = selectedOption.text, id = $$(selectedOption).data('econtract_id'), memo = $$(
				selectedOption).data("depository_memo"), econtract_name = $$(selectedOption).data('econtract_name');
		$$(".active-state").removeClass("active-state");
		APP_thirdBank.BankCode = $$(selectedOption).data('bankCode');
		APP_thirdBank.Bank = text;
		APP_thirdBank.bankType = type;
		APP_thirdBank.econtractId = id;
		if (econtract_name) {
			$$("#protocalLink").html("《<span id='bankName'></span>" + econtract_name + "》");
		} else {
			$$("#protocalLink").html("《<span id='bankName'></span>" + APP_thirdBank.Bank + "》三方协议");
		}
//		if (APP_thirdBank.Bank.indexOf("银行") > -1) {
//			$$("#sjyh_name").html(APP_thirdBank.Bank.substring(0, APP_thirdBank.Bank.indexOf("银行")) + "银行");
//		}
//		$$(".depo-banktip").show();
		$$(".content-block-title").show();
		if (memo && memo != " ") {
			$$(".warn-prompt-top .text").html(memo);
			$$(".warn-prompt-top").show();
		} else {
			$$(".warn-prompt-top").hide();
		}
		selectBankType(type);
		setActivityArea(APP_thirdBank.BankCode);
		_CMN.log("selectBank[MT][Bank="+APP_thirdBank.Bank+"][BankCode="+APP_thirdBank.BankCode+"][bankType="+APP_thirdBank.bankType+"]");
		setNextBtn();
	}
	function setActivityArea(t){
		if(APP_thirdBank.needShowActivity == "1") {
			_CMN.log("show["+t+"]active");
			$$(".activity-area").hide();
			$$(".activity-area-"+t).show();
		}
	}
	function selectBankType(type) {
		switch (type) {
		case '22':
			View.onlyCardNoInput(); // 卡号可填可不填
			$$('#bankHint').show();
			break;
		case '21':
			View.onlyCardNoInput(); // 只需填写卡号
			$$('#bankHint').show();
			break;
		case '12':
			View.onlyCardNoInput(); // 只需填写卡号
			$$('#bankHint').hide();
			break;
		case '11':
			View.bothCardNoPswInput(); // 同时需要填写卡号和密码
			$$('#bankHint').hide();
			break;
		case '31':
			View.onlyCardNoInput(); // 只需填写卡号
			// View.noNeedcyInput(); // 无需填写卡号密码
			break;
		case '32':
			View.onlyCardNoInput(); // 只需填写卡号
			// View.onlyCardNocyInput();// 只需填写卡号
			break;
		case '33':
			View.bothCardNoPswInput();
			break;
		case '34':
			View.bothCardNoPswInput();
			// View.onlyCardNocyInput();
			break;
		}
	}
	function submitFail(mess) {
		khApp.hideIndicator();
		khApp.alert(mess);
		$$('.depository-next-button').removeClass('disabled');
	}
	// 1:
	function nextSubmit() {
		setNextBtn(function() {
			var check = function(){
				if (APP_thirdBank.Bank == "") {
					khApp.alert("您还没有选择存管银行，请选择存管银行");
					return false;
				}
				// 11:一站式、需要帐号、密码;12:一站式、不需要密码;21:两站式、需要账号
				// 22 两站式、不需要账号(默认)=不需要银行卡号及密码
				if (APP_thirdBank.bankType == 11 || APP_thirdBank.bankType == 12 || APP_thirdBank.bankType == 21) {
					if (!/^[0-9]{8,30}$/.test(APP_thirdBank.accountNo)) {
						khApp.alert("银行卡号输入不正确，请重新输入");
						return false;
					}
				}
				if ($$(".cardpsw-input").css("display") == "block") {
					if (!/^[0-9]{6}$/.test(APP_thirdBank.accountPass)) {
						khApp.alert("银行卡密码输入不正确，请重新输入");
						$$("input[name=cardPSW]").val("");
						return false;
					}
				}
				if (APP_thirdBank.accountNo && appParams.inVaildCardNo && appParams.inVaildCardNo[APP_thirdBank.accountNo]) {
					khApp.alert("暂不支持信用卡，请重新绑定借记卡");
					return false;
				}
				return true;
			};
			
			APP_thirdBank.accountNo = $$("input[name=cardNo]").val().replace(/\s/g, '');
			APP_thirdBank.accountPass = $$("input[name=cardPSW]").val();
			if(check()){
				reqBankProtocal();
			}
		});
	}

	// 2:取银行协议md5内容
	function reqBankProtocal() {
		$$('.depository-next-button').addClass('disabled');
		khApp.showIndicator();
		$$.ajax({
			url : '/reqBankProtocal.do?rnd=' + new Date().getTime(),
			type : 'POST',
			timeout : 15000,
			data : {
				"bankCode" : APP_thirdBank.BankCode
			},
			success : function(d) {
				var data = JSON.parse(d);
				if (data.errorNo === 0) {
					APP_thirdBank.md5 = data.model.content;
					bindBankSubmit();
				} else {
					submitFail(data.errorInfo);
				}
			},
			error : function() {
				submitFail(MESSAGE_TIMEOUT);
			},
			timeout : function() {
				submitFail(MESSAGE_TIMEOUT);
			}
		});
	}
	// 3:
	function bindBankSubmit() {
		if (appParams.isUseCA == "true") {
			CERT.sign(APP_thirdBank.sn, APP_thirdBank.md5, "certSignCallBack");
		} else {
			APP_thirdBank.sn = "NOSN";
			certSignCallBack(0, "", APP_thirdBank.md5);
		}
	}
	// 4:
	function certSignCallBack(errorNo, errorInfo, signValue) {
		if (errorNo != 0) {
			submitFail("签名失败");
			return;
		}
		var bindUrl = "";
		if (APP_thirdBank.isReBind == "1") {
			bindUrl = '/reBind.do?rnd=' + new Date().getTime();
		} else {
			bindUrl = '/bind.do?rnd=' + new Date().getTime();
		}
		$$.ajax({
			url : bindUrl,
			type : 'POST',
			timeout : 15000,
			data : {
				"bankCode" : APP_thirdBank.BankCode,
				"accountNo" : APP_thirdBank.accountNo,
				"password" : APP_thirdBank.accountPass,
				"bankType" : APP_thirdBank.bankType,
				"signValue" : signValue,
				"cert_sn" : APP_thirdBank.sn,
				"isReBind" : APP_thirdBank.isReBind
			},
			success : function(d) {
				var data = JSON.parse(d);
				if (data.errorNo == 0) {
					CRHloadPage(APP_thirdBank.next);
					stepSync("openThirdPartyAccount");
				} else {
					submitFail(data['errorInfo']);
				}
			},
			error : function() {
				submitFail(MESSAGE_TIMEOUT);
			},
			timeout : function() {
				submitFail(MESSAGE_TIMEOUT);
			}
		});
	}
	window.certSignCallBack = certSignCallBack;

	// 显示银行列表
	function supportBankShow() {
		khApp.pickerModal('.bank-list-picker');
		$$('.customize-overlay').addClass('customize-overlay-visalbe');
	}
	function supportBankHide() {
		khApp.closeModal('.bank-list-picker');
		$$('.customize-overlay').removeClass('customize-overlay-visalbe');
	}
	function setLeftBtn(){
		var show = ($$("#removeLeftButton").val()!="1");
		if(!show){
			show = ($$(".depo-banknum-confirm").data("isshow")||'0')==='1';
		}
		$$(".left").css("visibility",show?"visible":"hidden");
	}
	function init() {
		window.scanBankCardCallBack = scanBankCardCallBack;
		APP_thirdBank.Bank = "";
		setLeftBtn();

		var h = $$(window).height();
		$$(window).resize(function() {
			if ($$(window).height() < h) {
				$$('.bank-list-block').hide();
			}
			if ($$(window).height() >= h) {
				$$('.bank-list-block').show();
			}
		});
		khApp.showIndicator();
		$$.ajax({
			url : '/listBank.do?rnd=' + new Date().getTime(),
			type : 'POST',
			success : function(d) {
				khApp.hideIndicator();
				var data = JSON.parse(d);
				if (data.errorNo === 0) {
					var deposityBankListNew = [];
					var deposityBankList = data.model.deposityBankList || [];
					for (var i = 0; i < deposityBankList.length; i++) {
						var bank = deposityBankList[i];
						var bankType = bank.bankType;
						bank.res_bank_no = bank.bank_no;
						if ("31" == bankType || "33" == bankType) {
							var bank_no = bank.bank_no;
							var pinyin = bank.pinyin;
							var depositySpecial1 = deepCopy(bank);
							var depositySpecial2 = deepCopy(bank);
							if ("31" == bankType) {
								depositySpecial1.bankType = "12";
								depositySpecial1.bank_no = bank_no + "_" + "12";
								depositySpecial1.pinyin = pinyin + "_" + "12";
								depositySpecial1.dict_prompt = "一步式，需账号";
								deposityBankListNew.push(depositySpecial1);
								depositySpecial2.bankType = "22";
								depositySpecial2.bank_no = bank_no + "_" + "22";
								depositySpecial2.pinyin = pinyin + "_" + "22";
								depositySpecial2.dict_prompt = "两步式，无需账号";
								deposityBankListNew.push(depositySpecial2);
							} else if ("33" == bankType) {
								depositySpecial1.bankType = "11";
								depositySpecial1.bank_no = bank_no + "_" + "11";
								depositySpecial1.pinyin = pinyin + "_" + "11";
								depositySpecial1.dict_prompt = "一步式需账号和密码";
								deposityBankListNew.push(depositySpecial1);
								depositySpecial2.bankType = "22";
								depositySpecial2.bank_no = bank_no + "_" + "22";
								depositySpecial2.pinyin = pinyin + "_" + "22";
								depositySpecial2.dict_prompt = "二步式，无需账号";
								deposityBankListNew.push(depositySpecial2);
							}
						} else {
							deposityBankListNew.push(bank);
						}
					}
					data.model.bankIconList = unique(deposityBankList);
					data.model.deposityBankList = deposityBankListNew;
					APP_thirdBank.deposityBankListNew = deposityBankListNew;
					render({
						model : data.model,
						bindings : APP_thirdBank.Bindings
					});
					renderBank({
						model : data.model,
						bindings : APP_thirdBank.Bindings
					});
					APP_thirdBank.needShowActivity = data.model.needShowActivity;
					APP_thirdBank.username = data.model.username || '';
					APP_thirdBank.sn = data.model.sn;
					APP_thirdBank.isReBind = $$("#isReBind").val();
					APP_thirdBank.todayrebind_trylimit = data.model.todayrebind_trylimit;
					if (data.model.todayrebind_trylimit && APP_thirdBank.isReBind == "1") {
						if (data.model.todayrebind_trylimit == "0") {
							$$(".depository-time-wrap").html('今日剩余绑定次数：<span class="depository-time">' + data.model.todayrebind_trylimit + '</span>，请临柜处理或下一交易日处理');
						} else {
							$$(".depository-time").html(data.model.todayrebind_trylimit);
						}
						$$(".depository-time-wrap").show();
					}
					initDepositoryInfo(data);
					setScanBankCardBtn();
					_CMN.log("depositoryNewController init finish");
				} else {
					khApp.alert(data.errorInfo);
				}
			},
			error : function() {
				khApp.hideIndicator();
				khApp.alert(MESSAGE_TIMEOUT);
			},
			timeout : function() {
				khApp.hideIndicator();
				khApp.alert(MESSAGE_TIMEOUT);
			}
		});
	}
	return {
		init : init
	};
});