define(['views/identityView', 'GS'], function (View, GS) {
	var bindings = [{
		element: '.identity-next-button',
		event: 'click',
		handler: verifySubmit
	}];
	
	//初始化
	function init() {
		View.render({
			bindings: bindings
		});
	}
	
	//下一步
	function verifySubmit() {
		var code = $$("#identityCode").val();
		code = $$.trim(code)
		if (code.length == 0 || code.length < 18 ) {
			khApp.alert('请正确输入身份证号');
			return;
		}
		khApp.hideIndicator();
		$$.ajax({
			method: 'POST',
			data: {'identitycode': code},
			url: '/identityVerify.do?rnd=' + new Date().getTime(),
			success: function(data){
				var d = JSON.parse(data);
				khApp.hideIndicator();
				if (d.errorNo===1) { // 身份证一致
					mainView.loadPage('/returnCert.do');
				} else {
					khApp.alert(d.errorInfo);
				}
			},
			error: function(){
				khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		},
	   		timeout: function(){
	   			khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		}
		});
	}

	return {
		init: init
	};
});
