define([ 'views/loginView', 'GS', 'services/openTypeService', 'utils', 'text!popup/iframe.html'],function(View, GS, OTS, Utils, IFrame) {

	var APP_login = {};
	APP_login.openType = "1";
	APP_login.next = "/photo";
	APP_login.pre = "/guide";
	APP_login.channel = "";
	APP_login.mac = "";//手机mac地址
	var deviceId = "";//设备号
	var uuid = "";//设备uuid
	var osVersion = "";//系统版本
	var phoneNumber = "";//本机号码

	APP_login.supperShorturl = "";
	var bindings = [ {
		element : '.login-submit',
		event : 'click',
		handler : loginSubmit
	}, {
		element : '.login-getcode',
		event : 'click',
		handler : getValidateCode
	}, {
		element : '.yzm-image',
		event : 'click',
		handler : getImage
	}, {
		element : '#login_nav_left',
		event : 'click',
		handler : returnPre
	}, {
		element : '#chLink',
		event : 'input propertychange',
		handler : validateShortUrl
	}, {
		element : '.depo-supportbank',
		event : 'click',
		handler : supportBankShow
	}, {
		element : '.bank-list-picker .right',
		event : 'click',
		handler : supportBankHide
	}, {
		element : '.mobile',
		event : 'input propertychange',
		handler : validateTel
	}, {
		element : '.password',
		event : 'input propertychange',
		handler : setButton
	}];
	window._DB = {
		rm:function(){
			window.localStorage.removeItem("cfzq_kh_confirm");
		},
		getItem:function(key){
			try{
				return window.localStorage.getItem(key)||'';
			}catch(e){
				return window[key]||'';
			}
		},
		setItem:function(key,val){
			try{
				window.localStorage.setItem(key,val);
			}catch(e){
				window[key]=val;
			}
		}
	};
	function showAgreement(fn){
		if (appParams.appId != "200") {
			return false;
		}
		var confirmFlag = _DB.getItem("cfzq_kh_confirm")||'false';
		if(confirmFlag == "false"){
			var fName = typeof(fn)=='function'?fn.name:"";
			//展示协议
			var content = '<div class="privacy-agreement-content">\
			      <p>尊敬的用户：在您开户之前，为了让您更好地了解我们是如何保护用户的个人信息，请您仔细阅读\
				  <a href="#" id="protocalLink" class="link-color" data-fn="'+fName+'">《隐私政策》</a>和<a href="#" id="protocalLink2" class="link-color" data-fn="'+fName+'">《服务协议》</a>。</p>\
			      <p>重点内容如下:</p>\
			      <p>1.当您注册帐号和使用服务时,根据监管需要与您的同意,获取手机号码、身份验证信息等。</p>\
			      <p>2.我们会使用Cookie与同类技术来确保服务正常运转。</p>\
			      <p>3.未经您的许可，我们不会向任何第三方提供您的信息，除法律要求外。</p>\
			      <p>4.具体内容点击上方蓝色链接查看，并以它为准。</p>\
			    </div>';
			    khApp.modal({
			      title: '<span class="privacy-agreement-title">隐私政策与服务协议</span>',
			      text: content,
			      buttons: [{
			        text: '<div class="link-color dialog-btn" style="color: gray;">不同意</div>',
			        onClick: function () {
			        	_DB.setItem("cfzq_kh_confirm","false");
			        }
			      },{
			        text: '<div class="link-color dialog-btn" style="color: red;">同意</div>',
			        onClick: function () {
			        	_DB.setItem("cfzq_kh_confirm","true");
			        	if(typeof(fn)=='function'){
							fn();
						}
			        }
			      }]
			    });
			    $$('#protocalLink').click(function() {
			    	khApp.closeModal();
			 		var u = 'https://www.cfzq.com/wsjy/cflz-ysxy.html';
			 		openIFrame(u,$$(this).data("fn"));
				});
			    $$('#protocalLink2').click(function() {
			    	khApp.closeModal();
			 		var u = 'https://www.cfzq.com/wsjy/cflz-yhxy.html';
			 		openIFrame(u,$$(this).data("fn"));
				});
			return true;
		}else{
			return false;
		}
	}

	/**
     * 打开协议
     */
    function openIFrame(src,fnName) {
        var iframe = document.createElement('iframe');
        var compiledTemplate = Template7.compile(IFrame);
        var model = {};
        model.webUrl = SERVICE_DOMAIN_URL;
        var renderTemplate = compiledTemplate({model: model});
        $$('.popup').html('').append(renderTemplate);
        $$('.popup #iframe').append(iframe);
        iframe.src = src;
        iframe.width = '100%';
        iframe.height = '100%';
        iframe.id = 'myIframe';
        khApp.popup('.popup');
        var fn = (fnName&&APP_login[fnName])?APP_login[fnName]:"";
        $$("#returnVideo").on("click", function () {
            khApp.closeModal();
            showAgreement(fn);
        });
    }
	function supportBankHide() {
		khApp.closeModal('.bank-list-picker');
		$$('.customize-overlay').removeClass('customize-overlay-visalbe');
	}

	function supportBankShow() {
		if (!$$(".picker-modal-inner").html()) {
			initBank();
		} else {
			khApp.pickerModal('.bank-list-picker');
			$$('.customize-overlay').addClass('customize-overlay-visalbe');
		}
	}

	function returnPre() {
		var openTypes = window.appParams.openType;
		if (befromFlag != "sjkh-default" && openTypes.length <= 1) {
			closeSJKH();
		}
	}
	function preparePositionReset(elem1, elem2) {
		var marginTop = $$('.page-content').eq($$('.page-content').length - 1).outerHeight() - $$(elem1).eq($$(elem1).length - 1).offset().top
				- $$(elem1).eq($$(elem1).length - 1).outerHeight() - $$(elem2).eq($$(elem2).length - 1).outerHeight() - parseInt($$(elem2).eq($$(elem2).length - 1).css('margin-bottom'));
		$$(elem2).css('margin-top', (marginTop > 35 ? marginTop : 35) + 'px');
		$$(elem2).css('position', 'static');
	}
	function eachAppId() {
		var appId = $$("#appId").val();
		if (appId) {
			var appJson = $$("#appIdLz").val().split(",");
			for (var i = 0; i < appJson.length; i++) {
				if (appId == appJson[i]) {
					return true;
				}
			}
		}
		return false;
	}

	function initBank() {
		khApp.showIndicator();
		$$.ajax({
			url : '/searchBank.do?rnd=' + new Date().getTime(),
			method : 'POST',
			success : function(d) {
				var data = JSON.parse(d);
				if (data.errorNo == 0) {
					View.renderBank({
						model : data.bankList,
						bindings : bindings
					});

					khApp.pickerModal('.bank-list-picker');
					$$('.customize-overlay').addClass('customize-overlay-visalbe');
				}
				khApp.hideIndicator();
			}
		});
		$$('.customisze-modal').hide();
	}
	function setType(type) {
		var typeData = OTS.getTypeData(type);
		if (typeData) {
			View.changeType(typeData.title, typeData.explain);
		}
	}
	/*y:是否手机号*/
	function isMobile(str) {
		var reg = /^[1][3456789]\d{9}$/;
		return reg.test(str);
	}

	function isVaildCode(str) {
		var reg = /^\d{4}$/;
		return reg.test(str);
	}

	function resetBtn() {
		$$('.login-getcode').html('重新获取验证码');
		$$('.login-getcode').removeClass('disabled');
		if (timer) {
			clearTimeout(timer);
		}
		curTime = 0;
	}
	/**获得图片验证码*/
	function getImage(func) {
		if ($$(".yzm-image").length == 0) {return;}
		var fail = function() {
			if ($$(".yzm-image").length == 0) {return;}
			khApp.alert(MESSAGE_TIMEOUT);
			resetBtn();
		};
		$$.ajax({
			url : '/getImageCode.do?rnd=' + new Date().getTime(),
			type : 'GET',
			datatype : 'json',
			success : function(d) {
				if ($$(".yzm-image").length == 0) {return;}
				var data = JSON.parse(d);
				if (data.errorNo == '0') {
					APP_login.getImageCodeFlag = "1";
					$$(".yzm-image").attr("src", data.src);
					if ($$('.img-code').find("img").length == 0) {
						if (func) {
							func();
						}
					} else {
						$$('.img-code').find("img").attr("src", data.src);
					}
				} else {fail();}
			},
			error : function() {fail();},
			timeout : function() {fail();}
		});
	}
	/**验证是否支持直接发短信*/
	function getNeedValidateFlag(c) {
		$$.ajax({
			url : '/getNeedValidateFlag.do?rnd=' + new Date().getTime(),
			type : 'POST',
			data : {
				"mobile_tel" : c.mobile_tel,
				"deviceId" : deviceId
			},
			success : function(d) {
				var data = JSON.parse(d);
				if (data.errorNo == "0") {
					wkAppClick("validateCode", $$(".login-getcode").html());
					APP_login.needValidateFlag = data.needValidateFlag;
					if (data.needValidateFlag == "1") {
						imageCodeModal(data.imageCodeMap);
					} else {
						c.succ(data);
					}
				} else if (data.errorNo == "12") {
					outStripSmsCodeNum(data);
				} else {
					khApp.alert(MESSAGE_TIMEOUT);
				}
			},
			error : function() {
				khApp.hideIndicator();
				khApp.alert(MESSAGE_TIMEOUT);
			},
			timeout : function() {
				khApp.hideIndicator();
				khApp.alert(MESSAGE_TIMEOUT);
			}
		});
	}
	/**获取短信验证码*/
	function getValidateCode() {
		var mobile_tel = $$('.mobile').val();
		if (isMobile(mobile_tel)) {
			getNeedValidateFlag({
				"mobile_tel" : mobile_tel,
				"succ" : function(data) {
					goVerify(mobile_tel, '');
				}
			});
		} else {
			khApp.alert('手机号码有误，请重新输入！');
		}
	}

	/**校验图形验证码*/
	function isVaildImageCode(str) {
		var reg = /^[0-9a-zA-Z]{4}$/;
		return reg.test(str);
	}

	var timer = null;
	var curTime = 0;
	var setTime = 60;
	/**获得短信验证码*/
	function goVerify(val, imageCode) {
		var btn = $$(".login-getcode");
		if (!$$(btn).hasClass('disabled')) {
			$$(btn).addClass('disabled');
		}
		setTime = parseInt($$("#notice_wait_time").val());
		var imagePassword = imageCode || $$('.imagePassword').val();
		$$.ajax({
			url : '/sendSmsVerifyCode.do?rnd=' + new Date().getTime(),
			method : 'POST',
			timeout : 15000,
			data : {
				"mphone" : val,
				"imagePassword" : imagePassword,
				"smsKey" : APP_login.smsKey,
				"device" : deviceId
			},
			success : function(d) {
				var data = JSON.parse(d);
				APP_login.getImageCodeFlag = "0";
				if (data.errorNo == '0') {
					$$('.code-tips').css("visibility", "hidden");
					$$('.password').focus();
					khApp.closeModal();
					function countDown(setTime) {
						if (timer) {
							clearTimeout(timer);
						}
						curTime++;
						var leftTime = setTime - curTime;
						if (leftTime > 0) {
							$$(btn).html(leftTime + '秒后重新获取');
							timer = setTimeout(function() {
								countDown(setTime);
							}, 1000);
						} else {
							getImage();
							resetBtn();
						}
					}
					curTime = 0;
					countDown(setTime);
					$$(".yzm-image").attr("src", data.src);
				} else if (data.errorNo == 12 || data.errorNo == 15) {
					khApp.closeModal();
					outStripSmsCodeNum(data);
					resetBtn();
				} else {
					if (data.errorInfo.indexOf("图片验证码不正确") > -1) {
						getImage(function(d) {
							imageCodeModal(d);
						});
						setTimeout(function() {
							$$('.imgCodeInput').val("");
						}, 500);
						$$('.code-tips').css('visibility', 'visible');
						$$(btn).removeClass('disabled');
					} else {
						khApp.closeModal();
						khApp.alert(data['errorInfo']);
						resetBtn();
					}
				}
			},
			error : function() {
				khApp.alert(MESSAGE_TIMEOUT);
				resetBtn();
			},
			timeout : function() {
				khApp.alert(MESSAGE_TIMEOUT);
				resetBtn();
			}
		});
	}

	function outStripSmsCodeNum(data) {
		var html = '<div class="crad-time">\
				<p style="margin:0;line-height:20px;text-align:left;color:#666;">' + data.errorInfo
				+ '</p>\
				<p style="margin:0;line-height:20px;text-align:left;color:#666;">详询客服热线95317。</p>\
			</div>';
		khApp.modal({
			title : '开户提示',
			text : html,
			buttons : [ {
				text : '确定'
			} ]
		});
	}

	/**输入图形验证码**/
	function imageCodeModal(json) {
		khApp.modal({
			title : '<p class="modal-title-content">图形验证</p>',
			text : '<div class="img-code-wrap">\
              <div class="img-code">\
                  <input type="tel" class="imgCodeInput" placeholder="请输入图形验证码" maxlength="4">\
                  <img class="security-code" src='
					+ SERVICE_DOMAIN_URL
					+ '"/template-3.0/img/security-code.png">\
              </div>\
              <p class="code-tips" style="visibility: hidden;">图形验证不通过，请重新输入</p>\
              <i class="icon iconfont icon-close" style="position:absolute;top:5px;right:12px;font-size:30px;">&#xe74f;</i>\
				</div>'
		});
		$$('.imgCodeInput').focus();
		$$('.img-code').find('img').attr("src", json.src);
		$$('.img-code-wrap').parent().parent().parent().css('margin-top', '-120px');
		$$('.img-code').find('input').on('input', function() {
			if ($$(this).val().length == 4) {
				goVerify($$(".mobile").val(), $$('.img-code').find('input').val());
			} else {
				$$('.code-tips').css('visibility', 'hidden');
			}
		});
		$$('.icon-close').click(function() {
			khApp.closeModal();
		});
	}
	/**
	 * 提供给乐赚的相关数据
	 * @param json
	 */
	function mobileInfoCB(data) {
		var json = {};
		json.mobile = data.mobile;
		if (data.channel_code) {
			json.channelId = data.channel_code;
			json.isMobileBinded = true;
		} else {
			json.isMobileBinded = false;
			json.channelId = "";
		}
		var jsonStr = JSON.stringify(json);
		if (browser.versions.ios) {
			window.location.href = "objc://mobileInfoCB/$?" + jsonStr;
		} else {
			if (window.jtoJHandle && window.jtoJHandle.mobileInfoCB) {
				window.jtoJHandle.mobileInfoCB(jsonStr);
			}
		}
	}

	/**登陆*/
	function loginSubmit() {
		var shortUrl = "";
		if (!APP_login.channel) {
			shortUrl = $$('#chLink').val();
			if (shortUrl && !numOrCharValidate(shortUrl)) {
				khApp.alert('推荐码有误，请重新输入');
				return;
			}
		}
		var valMobile = $$('.mobile').val();
		var valPassword = $$('.password').val();
		if (!isMobile(valMobile)) {
			khApp.alert('手机号码为空或有误，请重新输入');
		} else if (!timer) {
			khApp.alert('您还没有获取验证码，请先获取验证码');
		} else if (!isVaildCode(valPassword)) {
			khApp.alert('输入4位数字验证码');
		} else {
			if(showAgreement(loginSubmit)){
				return;
			}
			khApp.showIndicator();
			$$.ajax({
				url : '/register.do?rnd=' + new Date().getTime(),
				type : 'POST',
				timeout : 15000,
				data : {
					"mobile" : valMobile,
					"validateCode" : valPassword,
					"openType" : appParams.clientOpenType,
					"subOpenType":appParams.clientSubOpenType,
					"shortUrl" : APP_login.channel || shortUrl,
					'versionCode' : appParams.versionCode,
					'platform' : appParams.platform,
					'mac' : APP_login.mac,
					'deviceId' : encodeURIComponent(deviceId),
					'uuid' : encodeURIComponent(uuid),
					'osVersion' : getOsVersion(),
					'phoneNumber' : encodeURIComponent(phoneNumber),
					'device_flag' : browser.versions.ios ? "i" : "a"
				},
				success : function(d) {
					mainView.showNavbar();
					var data = JSON.parse(d);
					if (data.errorNo == '0') {
						var loginSucc = function(d) {
							mobileInfoCB(d);
							USER.mobile = valMobile;
							appParams.userId = data.userId;
							appParams.appId = data.appId;
							appParams.shortUrl = APP_login.channel;
							appParams.userOpenType = data.userOpenType;
							appParams.userSubOpenType = data.userSubOpenType;
							stepSync("Register");
							getUserInfo();
							CRHloadPage(APP_login.next);
						};
						if (data.isFirstReg != 'true') {
							searchChannelInfoByTel(loginSucc);
						} else {
							loginSucc({
								"mobile" : valMobile
							});
						}
					} else {
						getImage();
						$$(".imagePassword").val('');
						khApp.hideIndicator();
						resetBtn();
						khApp.alert(data['errorInfo']);
					}
				},
				error : function(error) {
					khApp.hideIndicator();
					khApp.alert(MESSAGE_TIMEOUT);
				},
				timeout : function(error) {
					khApp.hideIndicator();
					khApp.alert(MESSAGE_TIMEOUT);
				}
			});
		}
	}

	function getUserInfo() {
		$$.ajax({
			url : '/getUserInfo.do?rnd=' + new Date().getTime(),
			type : 'POST',
			timeout : 15000,
			data : {},
			success : function(d) {
				var data = JSON.parse(d);
				if (data.errorNo == '0') {
					appParams.userChannel = data.channel_id;
					wkPageView("login");
				}
			}
		});
	}

	function autoLogin(mobileNo) {
		if (isMobile(mobileNo)) {
			khApp.showPreloader('正在校验登录状态,请稍后....');
			$$.ajax({
				url : '/register2018.do?rnd=' + new Date().getTime(),
				type : 'POST',
				timeout : 15000,
				data : {
					"mobile" : mobileNo,
					"openType" : APP_login.openType,
					"shortUrl" : APP_login.channel,
					'mac' : APP_login.mac,

					'deviceId' : encodeURIComponent(deviceId),
					'uuid' : encodeURIComponent(uuid),
					'osVersion' : encodeURIComponent(osVersion),
					'phoneNumber' : encodeURIComponent(phoneNumber)
				},
				success : function(d) {
					mainView.showNavbar(); //显示头部导航（防止进来时设置不成功，再设置一次）
					var data = JSON.parse(d);
					if (data.errorNo == '0') {
						//保存手机号
						USER.mobile = mobileNo;
						CRHloadPage(APP_login.next);
					} else {
						khApp.hidePreloader();
						resetBtn();
						khApp.alert(data['errorInfo']);
					}
				},
				error : function(error) {
					khApp.hidePreloader();
					khApp.alert(MESSAGE_TIMEOUT);
				},
				timeout : function(error) {
					khApp.hidePreloader();
					khApp.alert(MESSAGE_TIMEOUT);
				}
			});
		}
	}

	function getRegistMobileNo() {
		if (!_CMN.isTHS()) {
			if (browser.versions.ios) {
				CRHClientbBrowser.loadObjURL("objc://callIOSGetRegistMobileNo/");
			}else if (window.jtoJHandle){
				jtoJHandle.getRegistMobileNo();
			}
		}

	}
	function getRegistMobileNoCallback(errorNo_, mobile, channel) {
		APP_login.channel = channel;
		if (channel) {
			$$("#chLink").val(channel);
			searchChannelInfo();
			if (befromFlag == "dzh") {
				$$("#referralInfo").hide();
			}
		}
		if (errorNo_ == 0) {//有手机号
			if (channel != "" && APP_login.supperShorturl != "") {
				var supperShorturl_arr = APP_login.supperShorturl.split(",");
				for (var i = 0; i < supperShorturl_arr.length; i++) {
					var s = supperShorturl_arr[i];
					if (s == channel) {
						setTimeout(function() {
							autoLogin(mobile);
						}, 500);
						break;
					}
				}

			}
		}
	}
	window.getRegistMobileNoCallback = getRegistMobileNoCallback;

	function getMacAddress() {
		if (browser.versions.ios) {
			window.location.href = "objc://getAdId/";
		} else {
			jtoJHandle.getMacAddress();
		}
	}

	function getMacAddrCallBack(mac) {
		APP_login.mac = mac;
	}
	window.getMacAddrCallBack = getMacAddrCallBack;

	function getDeviceInfo() {
		if (!_CMN.isTHS()) {
			if (browser.versions.ios) { //iphone
				CRHClientbBrowser.loadObjURL("objc://getDeviceInfo/?getDeviceInfoCallBack");
			} else {
				jtoJHandle.getDeviceInfo("getDeviceInfoCallBack");
			}
		}
	}

	function getThsMacAddress() {
		var json = {};
		json.action = "getMacAddress";
		json.reqId = new Date().getTime();
		window.thskaihu.reqApp(JSON.stringify(json));
	}

	function rspWeb(json) {
		var obj = JSON.parse(json);
		//解析返回的图片地址url
		var obj_data = obj.param;
		var action = obj.action;
		if (action == "getMacAddress") {
			deviceId = obj_data.macAddress;
		}
	}
	window.rspWeb = rspWeb;

	function getDeviceInfoCallBack(json) {
		var data = new Function("return" + json)();
		if (data.appdevicetoken) {
			device_token = data.appdevicetoken;
		}
		APP_login.mac = data.mac;
		if (data.deviceId) {
			deviceId = data.deviceId;
		}
		if (data.uuid) {
			uuid = data.uuid;
		}
		if (data.osVersion) {
			osVersion = data.osVersion;
		}
		if (data.phoneNumber) {
			phoneNumber = data.phoneNumber;
		}
	}
	window.getDeviceInfoCallBack = getDeviceInfoCallBack;

	function validateShortUrl() {
		$$("#recInfo").hide();
		var shortUrl = $$("#chLink").val();
		if (shortUrl.length >= 2 && shortUrl.length <= 11) {
			if (numOrCharValidate(shortUrl)) {
				searchChannelInfo();
				return;
			} else {
				khApp.alert("推荐码有误，请重新输入");
				$$("#chLink").val("");
			}
		}
	}

	function searchChannelInfo() {
		var shortUrl = $$('#chLink').val();
		$$.ajax({
			url : '/searchChannelInfo.do?rnd=' + new Date().getTime(),
			type : 'POST',
			data : {
				"shortNum" : shortUrl
			},
			success : function(d) {
				var data = JSON.parse(d);
				khApp.hideIndicator();
				if (data.errorNo == 0) {
					$$(".referrer-hint").hide();
					View.render({
						model : data
					});
					if (APP_login.channel == shortUrl) {//客户端绑定有效渠道则不能更改
						$$("#chLink").attr("readOnly", true);
					}
					if (eachAppId() && ($$("#short_url").val() || APP_login.channel)) {
						$$("#li_chLink").hide();
						$$("#referralInfo").show();
						$$("#recInfo").show();
					}
					if (data.channel_showbroker_flag != "1" && data.channel_showopenorg_flag != "1" && data.channel_showbrokercert_flag != "1") {
						$$("#recInfo").hide();
					}

				} else {
					$$('.referrer-hint').show();
					$$("#recInfo").hide();
				}
				preparePositionReset('.next-btn-block', '.prepare');
				if(!browser.versions.ios&&befromFlag == "wdkh"){
					throw "防止白屏而抛异常";
				}
			},
			error : function() {
				khApp.hideIndicator();
				khApp.alert(MESSAGE_TIMEOUT);
			},
			timeout : function() {
				khApp.hideIndicator();
				khApp.alert(MESSAGE_TIMEOUT);
			}
		});
	}
	/**y*/
	function setButton() {
		var mobile = $$("#set_mobile").val();
		var password = $$(".password").val();
		if (isMobile(mobile) && isVaildCode(password)) {
			$$(".login-submit").removeClass("disabled");
		} else {
			$$(".login-submit").addClass("disabled");
		}
	}
	/**y*/
	function validateTel() {
		setButton();
		var tel = $$("#set_mobile").val();
		var oldtel = $$("#set_mobile").data('oldtel');
		if (tel == oldtel) {
			return;
		}
		$$("#set_mobile").data('oldtel', tel);
		if (tel.length == 11) {
			if (!isMobile(tel)) {
				khApp.alert('手机号码有误，请重新输入');
			} else {
				getNeedValidateFlag({
					"mobile_tel" : tel,
					"succ" : function(data) {
					}
				});
			}
		}
	}
	function searchChannelInfoByTel(loginSucc) {
		var mobile_tel = $$('#set_mobile').val();
		khApp.showIndicator();
		$$.ajax({
			url : '/searchChannelInfoByTel.do?rnd=' + new Date().getTime(),
			type : 'POST',
			data : {},
			success : function(d) {
				var data = JSON.parse(d);
				console.info(data);
				data.mobile = mobile_tel;
				khApp.hideIndicator();
				if (data.errorNo == "0") {
					if (data.channel_showbroker_flag == "1" || data.channel_showopenorg_flag == "1" || data.channel_showbrokercert_flag == "1") {
						var html = "<div style='text-align:left;color:#7b7b7b'>您已在下列渠道注册<br/>";
						if (data.channel_showbroker_flag == "1") {
							html += "推荐人姓名：" + data.broker_name + "<br/>";
						}
						if (data.channel_showbrokercert_flag == "1") {
							html += "执业证书编号：" + data.profession_cert + "<br/>";
						}
						if (data.channel_showopenorg_flag == "1") {
							html += "开户营业部：" + data.branch_name + "<br/>";
						}
						html += "</div>";
						khApp.modal({
							title : '<div>开户提示</div>',
							text : html,
							buttons : [ {
								text : '继续开户',
								onClick : function() {
									khApp.closeModal();
									loginSucc(data);
								}
							} ]
						});
					} else {
						loginSucc(data);
					}
				} else {
					loginSucc({"mobile" : mobile_tel});
				}
			},
			error : function() {
				loginSucc({"mobile" : mobile_tel});
			},
			timeout : function() {
				loginSucc({"mobile" : mobile_tel});
			}
		});
	}
	function numOrCharValidate(val) {
		var reg = /^[A-Za-z0-9]*$/;
		return reg.test(val);
	}
	window.getSDKVersionCallBack = function(d) {
		try {
			_CMN.log("getSDKVersionCallBack d=【" + d + "】");
			var d1 = JSON.parse(d.replace(/\x00|\x0a/g, ''));
			var l;
			if(!browser.versions.ios){
				var v3 = '*';
				var exec1 = /([\d|.]+);/.exec(d1.exocrCardVersion || "");
				var exec2 = /([\d|.]+);/.exec(d1.exocrBankVersion || "");
				var exec3 = /Version: ([\d|.]+)TIME/.exec(d1.cwFaceVersion || "");
				if (exec1&&exec1.length >= 2) {
					v3 = exec1[1];
				}
				if (exec2&&exec2.length >= 2) {
					v3 = v3 + "-" + exec2[1];
				}
				l = [ d1.sdkVersion || "*", d1.anyChatVersion || "*", v3, (exec3&&exec3.length >= 2) ? exec3[1] : "*" ];
			}else{
				var v2=v3=v4='*';
				var exec2 = /(V[\d|.]+)Buildtime/.exec(d1.anyChatVersion || "");
				var exec31 = /:([\d|.]+)/.exec(d1.exocrCardVersion || "");
				var exec32 = /:([\d|.]+)/.exec(d1.exocrBankVersion || "");
				var exec41 = /Version:([\d|.]+)/.exec(d1.cwFaceVersion || "");
//				var exec42 = /LivenessVersion:([\d|.]+)/.exec(d1.cwFaceVersion || "");
				if(exec2&&exec2.length >=2){
					v2 = exec2[1];
				}
				if (exec31&&exec31.length >= 2) {
					v3 = exec31[1];
				}
				if (exec32&&exec32.length >= 2) {
					v3 = v3 + "-" + exec32[1];
				}
				if(exec41&&exec41.length>=2){
					v4 = exec41[1];
				}
//				if (exec42&&exec42.length >= 2) {
//					v4 = v4 + "-" + exec42[1];
//				}
				l = [ d1.sdkVersion || "*", v2, v3, v4];
			}
			$$(".version-r").each(function(i) {
				$$(this).html(l[i]);
			});
			$$(".version-wrapper").css("visibility", "visible");
		} catch (e) {
			_CMN.log("getSDKVersionCallBack e.message["+(e.message||'')+"]e.stack[" + (e.stack ||  '') + "]");
		}
	};
	var countt = 0;
	function getSDKVersion() {
		countt++;
		try {
			if (!_CMN.isTHS()||window.jtoJHandle) {
				if (browser.versions.ios) {
					if(appParams.videoAd=="-1"&&countt<11){
						setTimeout(function() {getSDKVersion();}, 500);
					}else if(appParams.videoAd&&appParams.videoAd!="-2"){
						CRHClientbBrowser.loadObjURL("objc://getSDKVersion/?getSDKVersionCallBack?"+appParams.videoAd);
					}
				} else if (window.jtoJHandle) {
					//jtoJHandle.getSDKVersion("getSDKVersionCallBack");
				}
			}
		} catch (e) {
			_CMN.log("getSDKVersion error[" + (e.stack || e.message || '') + "]");
		}
	}
	function init(query) {
		APP_login.supperShorturl = $$("#supperShorturl").val();
		APP_login.loginSubmit = loginSubmit;
		appParams.frontUrl = "";
		appParams.backUrl = "";
		appParams.faceUrl = "";
		appParams.showOther = 0;

		var openTypes = window.appParams.openType;
		if (openTypes > 1 || befromFlag != "sjkh-default") {
			$$("#login_nav_left_a").css("visibility", "visible");
		}

		var ext_mobile = $$("#ext_mobile").val();
		if (isMobile(ext_mobile)) {
			$$("#set_mobile").val(ext_mobile);
			$$("#set_mobile").attr("readOnly", false);
		}

		setTimeout(function() {
			getRegistMobileNo();
		}, 100);

		if (eachAppId() && ($$("#short_url").val() || APP_login.channel)) {
			if ($$("#short_url").val() && !APP_login.channel) {
				$$("#chLink").val($$("#short_url").val());
				if (SERVICE_DOMAIN_URL) {
					var css = function(t, s) {
						s = document.createElement('style');
						s.innerText = t;
						document.body.appendChild(s);
					};
					$$("#referralInfo ul").addClass("noBorder");
					css('.noBorder::after{height:0px !important;}');
					css('.noBorder::before{height:0px !important;}');
					searchChannelInfo();
				}
			}
		}
		setType(query.type);
		View.init({
			bindings : bindings
		});
		if (appParams.open_type) {
			APP_login.openType = appParams.open_type;
		}
		setTimeout(function() {
			getDeviceInfo();
		}, 500);
		setTimeout(function() {getSDKVersion();}, 500);
		preparePositionReset('.next-btn-block', '.prepare');
		setTimeout(function() {showAgreement();}, 900);
	}
	return {
		init : init
	};
});