define(['views/passwordView', 'GS'], function (View, GS) {

	var bindings = [{
		element: '.password-next-button',
		event: 'click',
		handler: nextSubmit
	}, {
		element: '#toggleSwitch',
		event: 'click',
		handler: handleSync
	},{
		element: '#password_nav .left',
		event: 'click',
		handler: returnPre
	}];

	function returnPre(){mainView.loadPage($$("#prePageUrl").val()||"/returnAccount.do");}
	
	function init() {
		View.render({
			bindings: bindings
		});
		APP_password.pwd_size =  $$("#pwd_size").val();
		
		if(APP_password.pwd_size == 8){
			$$("input[name=tradePwd]").attr("placeholder","输入6-8位数字交易密码");
			$$("input[name=commPwd]").attr("placeholder","请输入6-8位数字资金密码");
		} else if(APP_password.pwd_size == 7){
			$$("input[name=tradePwd]").attr("placeholder","输入6-7位数字交易密码");
			$$("input[name=commPwd]").attr("placeholder","请输入6-7位数字资金密码");
		}
		_CMN.log("passwordController init finish");
	}
	
	function handleSync() {
		setTimeout(toggleDisplay, 100);
	}

	function toggleDisplay() {
		var checkSync = document.querySelector('#checkSync');
		if (checkSync.checked) {
			View.toggleInputs('hide');
			$$("#small").html("设置交易密码<small></small>");
		} else {
			View.toggleInputs('show');
			$$("#small").html("设置交易密码<small></small>");
		}
	}

	var APP_password            = {};
	APP_password.tradePwd       = "";
	APP_password.tradePwdRepeat = "";
	APP_password.capitalPwd     = "";
	APP_password.commPwd        = "";
	APP_password.commPwdRepeat  = "";
	//密码的长度默认为6位
	APP_password.pwd_size       = 6;
	
	function isNums(str){
		var reg = /^\d{6}$/;
		if(APP_password.pwd_size == 8){
			reg = /^\d{6,8}$/;
		} else if(APP_password.pwd_size == 7) {
			reg = /^\d{6,7}$/;
		}
		return reg.test(str);
	}
	
	function nextSubmit() {
		
		if($$("#checkSync")[0].checked){
			APP_password.tradePwd = $$("input[name=tradePwd]").val();
			APP_password.tradePwdRepeat = $$("input[name=tradePwdRepeat]").val();
			
			APP_password.commPwd = APP_password.tradePwd;
			APP_password.commPwdRepeat = APP_password.tradePwdRepeat;
			
			APP_password.capitalPwd = APP_password.tradePwd;
			
			if(APP_password.tradePwd == "" || APP_password.tradePwd == null){
				khApp.alert('请输入交易密码');
				return;
			}

			
			if(APP_password.tradePwd != APP_password.tradePwdRepeat){
				khApp.alert('两次交易密码输入不一致，请重新输入');
				$$("input[name=tradePwd]").val("");
				$$("input[name=tradePwdRepeat]").val("");
				return;
			}
			if(!isNums(APP_password.tradePwd)){
				if(APP_password.pwd_size == 6){
					khApp.alert('请输入6位数字交易密码');
				} else if(APP_password.pwd_size == 8) {
					khApp.alert("密码为6-8位数字，请重新输入");
				} else if(APP_password.pwd_size == 7) {
					khApp.alert("密码为6-7位数字，请重新输入");
				}
				return;
			}
		}else{
			APP_password.tradePwd = $$("input[name=tradePwd]").val();
			APP_password.tradePwdRepeat = $$("input[name=tradePwdRepeat]").val();
			APP_password.commPwd = $$("input[name=commPwd]").val();
			APP_password.commPwdRepeat = $$("input[name=commPwdRepeat]").val();
			APP_password.capitalPwd = APP_password.commPwd;
			
			if(APP_password.tradePwd == "" ||APP_password.tradePwd == null){
				khApp.alert('请输入交易密码');
				return;
			}
			
			if(APP_password.tradePwd != APP_password.tradePwdRepeat){
				khApp.alert('两次交易密码输入不一致，请重新输入');
				$$("input[name=tradePwd]").val("");
				$$("input[name=tradePwdRepeat]").val("");
				return;
			}
			
			if(APP_password.commPwd == "" ||APP_password.commPwd == null){
				khApp.alert('请输入资金密码');
				return;
			}
			if(APP_password.commPwd != APP_password.commPwdRepeat){
				khApp.alert('两次资金密码输入不一致，请重新输入');
				$$("input[name=commPwd]").val("");
				$$("input[name=commPwdRepeat]").val("");
				return;
			}
			if(!isNums(APP_password.commPwd)){
				if(APP_password.pwd_size == 8){
					khApp.alert('请输入6-8位数字资金密码');
				} else if(APP_password.pwd_size == 7){
					khApp.alert('请输入6-7位数字资金密码');
				} else {
					khApp.alert('请输入6位数字资金密码');
				}
				return;
			}
		}
		$$(".password-next-button").addClass('disabled');
		khApp.showIndicator();
		$$.ajax({
			url: '/setPassword.do?rnd=' + new Date().getTime(),
			method: "POST",
			timeout: 15000,
			data: {
				"tradePwd"         : APP_password.tradePwd,
				"capitalPwd"       : APP_password.commPwd,
				"communicationPwd" : APP_password.tradePwd
			},
			success: function(data0){
				var data = JSON.parse(data0);
				if(data.errorNo === 0){
                    stepSync("setPassword");
					CRHloadPage('/callback');
				}else{
					khApp.hideIndicator();
					$$(".password-next-button").removeClass('disabled');
				    khApp.alert(data.errorInfo);
				}
	   		 },
			error: function(){
	   			khApp.hideIndicator();
				$$(".password-next-button").removeClass('disabled');
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		},
	   		timeout: function(){
	   			khApp.hideIndicator();
	   			$$(".password-next-button").removeClass('disabled');
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		}
		 });
	}

	return {
		init: init
	};
});