define(['utils','views/resetChannelView'], function (Utils,View) {

	nextpage="/audit";
  var bindings = [{
    element: '.query',
    event: 'click',
    handler: query
  }, {
    element: '.close',
    event: 'click',
    handler: close
  }, {
    element: '.reset-channel',
    event: 'click',
    handler: resetChannel
  }];

  function init() {
    Utils.bindEvents(bindings);
  }

  function query() {
    var val = $$('#channelCode').val();
    console.log(val);
    if (!val) {
      khApp.alert('请输入渠道短码');
    } else {
    	$$.ajax({
				url: '/searchChannel.do?rnd=' + new Date().getTime(),
				type: 'POST',
				timeout: 15000, //超时时间设置，单位毫秒
				data: {
					"shortUrl": val,
				},
				success: function (data) {
					var data = JSON.parse(data);
					console.info(data);
					if (data.errorNo == '0') {
						View.render({
				            model: data,
				            bindings: bindings
				        });
				        $$("#tip").show();
					    $$('.current-channel').show();
					} else {
						khApp.hideIndicator();
						khApp.alert("渠道查询出错");
					}
				},
				error: function(error){
					khApp.hideIndicator();
		   			khApp.alert(MESSAGE_TIMEOUT);
		   		},
		   		timeout: function(error){
		   			khApp.hideIndicator();
		   			khApp.alert(MESSAGE_TIMEOUT);
		   		}
			});
    }
  }
  
  function resetChannel(){
  	var val = $$('#channelCode').val();
    console.log(val);
    if (!val) {
      khApp.alert('请输入渠道短码');
    } else {
    	$$.ajax({
				url: '/resetShortUrl.do?rnd=' + new Date().getTime(),
				type: 'POST',
				timeout: 15000, //超时时间设置，单位毫秒
				data: {
					"shortUrl": val,
				},
				success: function (data) {
					var data = JSON.parse(data);
					console.info(data);
					if (data.errorNo == '0') {
						CRHloadPage(nextpage);	//下一步
					} else {
						khApp.hideIndicator();
						khApp.alert("渠道设置出错");
					}
				},
				error: function(error){
					khApp.hideIndicator();
		   			khApp.alert(MESSAGE_TIMEOUT);
		   		},
		   		timeout: function(error){
		   			khApp.hideIndicator();
		   			khApp.alert(MESSAGE_TIMEOUT);
		   		}
			});
    }
  }

  function close() {
  	$$("#tip").hide();
    $$('.current-channel').hide();
  }

  return {
    init: init
  };
});