define([ 'views/reviewView', 'GS' ], function(View, GS) {
	var APP_review = {};
	APP_review.warn = "根据问卷回访结果，您将不能继续开户！";
	APP_review.bindings = [ {
		element : '.review-next-button',
		event : 'click',
		handler : nextSubmit
	}, {
		element : '.select-trigger',
		event : 'click',
		handler : selectTrigger
	}, {
		element : '#reviewLeft',
		event : 'click',
		handler : function() {
			mainView.loadPage("/returnPwdset.do");
		}
	} ];

	function init() {
		khApp.showIndicator();
		$$.ajax({
			url : '/getCallback.do?rnd=' + new Date().getTime(),
			type : 'POST',
			success : function(d) {
				var data = JSON.parse(d);
				if (data.errorNo == 0) {
					var questions = [];
					for (var i = 0; i < data.callbackList.length; i++) {
						var risk = {};
						risk.index = i + 1;
						risk.topic = data.callbackList[i].question_content;
						if (data.callbackList[i].question_kind == "1") {
							risk.multi = true;
						}
						risk.options = [];
						risk.question_no = data.callbackList[i].question_no;
						for ( var p in data.callbackList[i].answer_content) {
							var option = {};
							option.option = data.callbackList[i].answer_content[p];
							option.value = p;
							option.groupId = data.callbackList[i].question_no;
							if (data.callbackList[i].default_answer.indexOf(p) != -1) {
								option.checked = true;
							}
							option.warnTip = data.callbackList[i].warn_tip;
							option.tip = data.callbackList[i].tip;
							risk.options.push(option);
						}
						questions.push(risk);
					}
					var model = {
						questions : questions
					};

					View.render({
						bindings : APP_review.bindings,
						model : model
					});
					khApp.hideIndicator();
					_CMN.log("reviewController init finish");
				} else {
					khApp.alert(data.errorInfo);
				}
			}
		});
	}

	function nextSubmit() {
		var checked = checkDefault();

		// 检查不通过就 return 掉
		if (checked.length > 0) {
			khApp.alert(checked[0].warn ? checked[0].warn : APP_review.warn);
			return;
		}

		// resultData 为 {question_no: value} 的 Object 组
		var resultData = khApp.formToJSON('#reviewContent');
		var resultArray = [];
		var answers;

		for ( var i in resultData) {
			var _result = i + '&' + resultData[i];
			resultArray.push(_result);
		}
		// 最终格式为：question_no&value|question_no&value|question_no&value...
		answers = resultArray.join('|');

		khApp.showIndicator();
		$$.ajax({
			url : '/submitCallback.do?rnd=' + new Date().getTime(),
			method : 'POST',
			data : {
				"answers" : encodeURIComponent(answers)
			},
			success : function(data) {
				var d = JSON.parse(data);
				if (d.errorNo == 0) {
					stepSync("Revisitpaper");
					CRHloadPage("/video");
				} else {
					khApp.hideIndicator();
					khApp.alert(d.errorInfo);
				}
			}
		});

	}

	/**
	 * 点击跟随选择
	 * @return {void}
	 */
	function selectTrigger() {
		var radio = $$(this).parent().find('input[type=radio]');
		$$(this).parent().parent().find('.select-trigger').removeClass("checked");
		$$(this).addClass("checked");
		radio[0].checked = true;
	}

	/**
	 * 检查选择是否为默认
	 * @return {Array} 返回错误序列与错误信息
	 */
	function checkDefault() {
		var result = [];

		$$('.default').each(function(index) {
			if (!this.checked) {
				var warn = $$(this).data('warn');
				result.push({
					index : index + 1,
					warn : warn
				});
			}
		});

		return result;
	}
	return {
		init : init
	};
});