define([ 'views/riskView', 'GS' ], function(View, GS) {
	'use strice';
	var APP_risk = {};
	APP_risk.stopChoices = [];
	APP_risk.bindings = [ {
		element : '.risk-submit-button',
		event : 'click',
		handler : nextSubmit
	}, {
		element : '#riskLeft',
		event : 'click',
		handler : function() {
			mainView.loadPage("/returnSetBank.do");
		}
	}, {
		element : '.topic-option',
		event : 'click',
		handler : autoNext
	} ];
	APP_risk.navbar_height = $$('.navbar').outerHeight();

	function init() {
		khApp.showIndicator();
		$$.ajax({
			url : '/getRisk.do?rnd=' + new Date().getTime(),
			type : 'POST',
			success : function(d) {
				var data = JSON.parse(d);
				if (data.errorNo == 0) {
					if (data.stopChoices) {
						var c = data.stopChoices.split('|');
						if (c.length == 3) {
							APP_risk.stopChoices = c;
						}
					}
					var questions = [];
					var l = 1;
					for (var i = 0; i < data.riskList.length; i++) {
						var risk = {};
						risk.index = l;
						risk.topic = data.riskList[i].question_content;
						if (risk.topic.indexOf("您的年龄") >= 0) {
							var age = data.age * 1;
							if (age >= 70 && age < 18) {
								data.riskList[i].default_answer = "1";
							} else if (age >= 18 && age <= 30) {
								data.riskList[i].default_answer = "2";
							} else if (age >= 31 && age <= 45) {
								data.riskList[i].default_answer = "3";
							} else if (age >= 46 && age <= 55) {
								data.riskList[i].default_answer = "4";
							} else {
								data.riskList[i].default_answer = "5";
							}
							if (data.hideExam + "" == "1") {
								risk.visible = "hidden";
								risk.index = "-1";
							} else {
								l++;
							}
						} else if (risk.topic.indexOf("您的最高学历") >= 0) {
							if (data.degreeCode == "5" || data.degreeCode == "6" || data.degreeCode == "7" || data.degreeCode == "8" || data.degreeCode == "05" || data.degreeCode == "06"
									|| data.degreeCode == "07" || data.degreeCode == "08") {
								data.riskList[i].default_answer = "1";
							} else if (data.degreeCode == "4" || data.degreeCode == "04") {
								data.riskList[i].default_answer = "2";
							} else if (data.degreeCode == "3" || data.degreeCode == "03") {
								data.riskList[i].default_answer = "3";
							} else if (data.degreeCode == "2" || data.degreeCode == "1" || data.degreeCode == "02" || data.degreeCode == "01") {
								data.riskList[i].default_answer = "4";
							} else {
								data.riskList[i].default_answer = "5";
							}
							if (data.hideExam + "" == "1") {
								risk.visible = "hidden";
								risk.index = "-1";
							} else {
								l++;
							}
						} else {
							l++;
						}
						if (data.riskList[i].question_kind == "1") {
							risk.multi = true;
						}
						risk.options = [];
						risk.question_no = data.riskList[i].question_no;
						for ( var p in data.riskList[i].answer_content) {
							var option = {};
							option.option = data.riskList[i].answer_content[p];
							option.value = p;
							option.question_no = data.riskList[i].question_no;
							if (data.riskList[i].default_answer.indexOf(p) != -1) {
								option.checked = true;
							}
							risk.options.push(option);
						}
						questions.push(risk);
					}
					var model = {
						questions : questions
					};
					View.render({
						bindings : APP_risk.bindings,
						model : model
					});
					khApp.hideIndicator();
					_CMN.log("riskController init finish");
				} else {
					khApp.alert(data.errorInfo);
				}
			}
		});
	}
	/**
	 * 滚动至对应的题目
	 * @param {Number|String} index 题目的序列号
	 * @return {void}
	 */
	function scrollToTopic(index) {
		try {
			var topic = $$('#topic_' + index);
			if (topic[0]) {
				var tmp = parseInt(topic.css('margin-top').replace('px', ''), 10);
				var top = topic[0].offsetTop - (isNaN(tmp) ? 0 : tmp) - APP_risk.navbar_height;
				if (!isNaN(top) && top > 0) {
					$$('#riskContent').scrollTop(top, 200);
				}else{
					_CMN.log("scrollToTopic info:[index=" + (index || '') + "][befromFlag=" + (befromFlag || '') + "][ua=" + (navigator.userAgent || '') + "][app=" + (navigator.appVersion || '') + "]");
				}
			}
		} catch (e) {
			_CMN.log("scrollToTopic error:" + (e.stack || e.message || ''));
			_CMN.log("scrollToTopic error:[index=" + (index || '') + "][befromFlag=" + (befromFlag || '') + "][ua=" + (navigator.userAgent || '') + "][app=" + (navigator.appVersion || '') + "]");
		}
	}
	/**
	 * 点击题目选项自动滚动到下一题
	 * @return {void}
	 */
	function autoNext() {
		event.stopPropagation();
		if (APP_risk.stopChoices && APP_risk.stopChoices.length == 3) {
			var c = APP_risk.stopChoices;
			var $opt = $$(this).find('INPUT');
			if ($opt.length > 0 && $opt.attr('name') == c[0] && $opt.attr('value') == c[1]) {
				setTimeout(function() {
					$opt[0].checked = false;
				}, 200);
				khApp.alert(c[2]);
				return false;
			}
		}
		var index = $$(this).data('index');
		if (index === 'multi'){
			return;
		}
		var nextIndex = +index + 1;
		setTimeout((function(_this) {
			return function() {
				var checked = $$(_this).find('input:checked');
				if (checked.length > 0) {
					scrollToTopic(nextIndex);
				}
			};
		})(this), 200);
	}

	/**
	 * 检查题目是否做完
	 * @return {Array} 未做完题目的序列号
	 */
	function checkAll() {
		var result = [];
		$$('.topic-options').each(function(index) {
			var checked = $$(this).find("input:checked");
			if (checked.length === 0) {
				result.push(index + 1);
			}
		});
		return result;
	}

	/**
	 * 格式化评测答案
	 * @return {Array} 格式化后的数据
	 */
	function formatAnswers() {
		// resultData 为 {question_no: value} 的 Object 组
		// value 可能为 String 类型（单选），也可能为数组（多选）
		var resultData = khApp.formToJSON('#riskForm');
		var resultArray = [];

		for ( var i in resultData) {
			var _result;
			if (resultData[i] instanceof Array) {
				_result = i + '&' + resultData[i].join('^');
			} else {
				_result = i + '&' + resultData[i];
			}
			resultArray.push(_result);
		}
		// 最终格式为：question_no&value|question_no&value|question_no&value^&value...
		return resultArray.join('|');
	}

	function nextSubmit() {
		var errIndex = checkAll();
		$$(".risk-submit-button").addClass('disabled');
		if (errIndex.length > 0) {
			khApp.alert('还有尚未完成的题目', function() {
				scrollToTopic(errIndex[0]);
			});
			$$(".risk-submit-button").removeClass('disabled');
			return;
		}
		var answers = formatAnswers();
		$$.ajax({
			url : '/submitRisk.do?rnd=' + new Date().getTime(),
			type : 'POST',
			data : {
				"answers" : encodeURIComponent(answers)
			},
			success : function(d) {
				var data = JSON.parse(d);
				if (data.errorNo == 0) {
					stepSync("Testpaper");
					CRHloadPage("/examResult.do");
				} else {
					$$(".risk-submit-button").removeClass('disabled');
					khApp.alert(data.errorInfo);
				}
			}
		});
	}
	return {
		init : init
	};
});