define(['utils', 'GS'], function (Utils, GS) {


    var APP_risk = {};
    APP_risk.cert_sn = "";
    APP_risk.signValue = "";
  var afterBindings = [{
      element:'.button-list-block .cancel',
      event: 'click',
      handler: noticeCancel
  },{
      element:'.button-list-block .confirm',
      event: 'click',
      handler: nextSubmit
  },{
      element:'.button-list-block .no-agree',
      event: 'click',
      handler: noAgree
  },{
      element:'.button-list-block .agree',
      event: 'click',
      handler: nextSubmit
  },{
      element: '.goBack',
      event: 'click',
      handler: function () {
          mainView.loadPage("examResult.do");
      }
  }];

    function noticeCancel(){
        khApp.modal({
            title: '开户提示',
            text: '<div style="text-align: left">你是否确定无法接受风险并退出开户流程？</div>',
            buttons: [{
                text: '否'
            },{
                text: '<div style="font-weight:bold">是</div>',
                onClick:function () {
                    GS.logout();
                }
            }]
        });
    }
    function noticeConfirm(){
        var html = "";
        if(riskResultQuery.suit_flag == "0"){
            html = '<p>您拟开通的【A股证券账户】业务风险等级为【'+riskResultQuery.prod_suit_prop_name+'】 ，与您在客户风险评估中所显示的风险承受能力等级<span style="color: red">相匹配</span>。</p>'+
                '<p class="bold">本人开通【A股证券账户】业务的决定，系本人独立、自主、真实的意思表示，与财富证券及其相关从业人员无关。</p>';
        }else{
            html =    '<p>您拟开通的【A股证券账户】业务风险等级为【'+riskResultQuery.prod_suit_prop_name+'】 ，<span style="color: red">高于</span>您在客户风险评估中所显示的风险承受能力等级。</p>'+
               '<p class="bold">本人在认真阅读财富证券关于【A股证券账户】业务相关风险警示后，充分知悉：本人风险承受能力低于【中风险】，但经本人审慎考虑后，仍坚持开通该业务，愿意承担可能引起的损失和其他后果，并承诺开通【A股证券账户】业务的决定为真实自愿行为。</p>'
        }
        khApp.modal({
            title:  '适当性匹配详情',
            text: '<div  id="confirmModal" class="letter-of-agreement">' +
            '<div class="content " > ' +
                html +
            '</div>' +
            '<div class="button-list-block"> ' +
            '<a href="#" class="button button-big button-cancle cancel">放弃办理</a> ' +
            '<a href="#" class="button button-big button-fill confirm" style="text-overflow: clip;padding: 0;">我已确认并同意</a> ' +
            '</div>' +
            '</div>',
            //'<a href="#" class="button button-big button-fill confirmation-btn">已阅读并同意签署</a>',
        });

        //改变modal的宽度
        $$('#confirmModal').parents('.modal').css({'width':'80%','margin-left':'-40%'});

        $$('#confirmModal .cancel').on('click', function(event) {
            khApp.closeModal();
            GS.logout();
        });
        $$('#confirmModal .confirm').on('click', function(event) {
            khApp.closeModal();
            $$("#confirmModal .confirm").addClass("disabled");
            khApp.showIndicator();
            nextSubmit();
        });
    }

    function noAgree(){
        khApp.modal({
            title: '开户提示',
            text: '<div style="text-align: left">您是否不认同确认书并退出开户流程？</div>',
            buttons: [{
                text: '<div style="color: #7e7e7e" >否</div>'
            },{
                text: '是',
                onClick:function () {
                    GS.logout();
                }
            }]
        });
    }

    var resultList;
    var riskResultQuery;
  function init() {
      //判断是否使用CA
      if( appParams.isUseCA == "true"){
          findSn();
      }
    khApp.showIndicator();
    $$.ajax({
      url: '/getRiskSuitProtocal.do?v='+new Date().getTime(),
      type: 'POST',
        data:{
            protocal_flag:"0"
        },
      success: function (data) {
        data = JSON.parse(data);
        if (data.errorNo == 0) {
            APP_risk.cert_sn = data.cert_sn;
            resultList = data.resultList;
            riskResultQuery = data.riskResultQuery;
          renderResult({
            model: data,
            bindings: afterBindings
          });
        }
        khApp.hideIndicator();
      }
    });
  }


  function nextSubmit() {
//判断是否使用CA
      if( appParams.isUseCA == "true"){
          //对协议进行签名
          APP_risk.protocalElem = resultList;
          APP_risk.protocalElemLength = APP_risk.protocalElem.length;//需要签名数量
          if(APP_risk.protocalElemLength > 0){
              var obj = APP_risk.protocalElem[0];
              var agreementNo = obj.econtract_id;
              var value = obj.econtract_md5;
              CERT.sign(APP_risk.sn,value,"protocalSignRiskCallBack");
          }
      }else{
          simulateSign();//不用CA
      }
  }

    //签名回调方法
    function protocalSignRiskCallBack(errorNo, errorInfo, signValue) {
        if (errorNo == "-3") {
            khApp.alert("未找到数字证书，请重新下载数字证书");
            return;
        }
        if (errorNo == "-2") {
            khApp.alert("开户协议签名出错，请确认是否正确安装数字证书");
            return;
        }
        if (errorNo == "-1") {
            khApp.alert("数字证书出错，请确认是否正确输入数字证书密码");
            return;
        }
        var protocalElem = resultList;
        var protocalElemLength = protocalElem.length;
        for(var i = 0;i<protocalElemLength; i++){
            var obj_temp = protocalElem[i];
            if(signValue == ""){
                signValue += obj_temp.econtract_id + ";" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5+";";
            }else{
                signValue += "|" + obj_temp.econtract_id + ";" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5+";";
            }
        }
        APP_risk.hasSignSize++;
        //进行循环签名
        if (APP_risk.hasSignSize != APP_risk.protocalElemLength) {
            if (APP_risk.hasSignSize < APP_risk.protocalElemLength) {
                var obj = protocalElem[i];
                var value = obj.econtract_md5;
                //签名
                CERT.sign(APP_risk.cert_sn, value, "protocalSignCallBack");
            }
            return;
        }
        $$(".risk-next-button").addClass('disabled');
        khApp.showIndicator();
        $$.ajax({
            url: '/protocalSign.do?rnd=' + new Date().getTime(),
            type: "POST",
            timeout:15000,
            data:  {
                "signValue"    : signValue,
                "cert_sn"      : APP_risk.cert_sn,
                "biz_id"       : "10087"
            },
            success: function(data_){
                khApp.hideIndicator();
                var data = JSON.parse(data_);
                if(data.errorNo === 0){
                    stepSync("Riskbook");
                    mainView.loadPage("/signAppropriateResult.do");
                }else{
                    $$(".risk-next-button").removeClass('disabled');
                    khApp.alert(data.errorInfo);
                }
            },
            error: function(){
                khApp.hideIndicator();
                $$(".risk-next-button").removeClass('disabled');
                khApp.alert(MESSAGE_TIMEOUT);
            },
            timeout: function(){
                khApp.hideIndicator();
                $$(".risk-next-button").removeClass('disabled');
                khApp.alert(MESSAGE_TIMEOUT);
            }
        });
    }
    window.protocalSignRiskCallBack = protocalSignRiskCallBack;

    //模拟签名并提交
    function simulateSign(){
        //对协议进行签名
        APP_risk.signValue = "";
        APP_risk.protocalElem = resultList;
        APP_risk.protocalElemLength = APP_risk.protocalElem.length;//需要签名数量
        for(var i=0; i<APP_risk.protocalElemLength;i++){
            var obj_temp = APP_risk.protocalElem[i];
            if(APP_risk.signValue == ""){
                APP_risk.signValue += obj_temp.econtract_id + ";" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5;
            }else{
                APP_risk.signValue += "|" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5 + ";" + obj_temp.econtract_md5;
            }
        }
        khApp.showIndicator();
        $$(".sign-next-button").addClass('disabled');
        $$.ajax({
            url: '/protocalSign.do?rnd=' + new Date().getTime(),
            method: "POST",
            timeout:15000,
            data:  {
                "signValue"    : APP_risk.signValue,
                "cert_sn"      : "NOSN",
                "biz_id"       : "10087"
            },
            success: function(data){
                khApp.hideIndicator();
                var data = JSON.parse(data);
                if(data.errorNo === 0){
                    stepSync("Riskbook");
                    mainView.loadPage("/signAppropriateResult.do");
                }else{
                    $$(".sign-next-button").removeClass('disabled');
                    khApp.alert(data.errorInfo);
                }
            },
            error: function(){
                khApp.hideIndicator();
                $$(".sign-next-button").removeClass('disabled');
                khApp.alert(MESSAGE_TIMEOUT);
            },
            timeout: function(){
                khApp.hideIndicator();
                $$(".sign-next-button").removeClass('disabled');
                khApp.alert(MESSAGE_TIMEOUT);
            }
        });
    }

  function renderResult(params) {
    var template = $$('#riskNoticeTemplate').html();
    var compiledTemplate = Template7.compile(template);
    var renderTemplate = compiledTemplate({model: params});

    $$('#riskNoticeContent').html(renderTemplate);

    Utils.bindEvents(params.bindings);


  }


  return {
    init: init
  };
});
