define(['views/ttlView'], function (View) {

	var APP_Ttl = {};
	APP_Ttl.econtractId = "";
	APP_Ttl.pre = "/openaccount";
	APP_Ttl.next = "/pwdset";
	APP_Ttl.sn = "";
	APP_Ttl.md5 ="";
	APP_Ttl.ttlAccount = "1";
	
	var bindings = [{
		element: '.button-fill',
		event: 'click',
		handler: nextSubmit
	},{
		element:'#ttlLink',
		event: 'click',
		handler:displayProtocal
	},{
		element: '#ttl_nav .left',
		event: 'click',
		handler: returnPre
	}];
	
	function returnPre(){
		CRHloadPage("/returnAccount.do");
	}

	function init() {
		APP_Ttl.econtractId = "";
		APP_Ttl.sn = "";
		APP_Ttl.md5 ="";
		APP_Ttl.ttlAccount = "1";
		
		//判断是否使用CA
		if( appParams.isUseCA == "true"){
			findSn();
		}
		
		View.render({
			bindings: bindings
		});
		
		khApp.showPreloader('正在获取协议,请稍后...');
		getEcontractIdFunction();
	}
	
	function getEcontractIdFunction (){
		var econtract_type = 8;
		$$.ajax({
			url: '/getEcontractId.do?rnd=' + new Date().getTime(),
			type: 'POST',
			data: { "econtract_type" : econtract_type},
			success: function (data) {
				khApp.hidePreloader();
				data = JSON.parse(data);
				if (data.errorNo == 0) {
					APP_Ttl.econtractId = data.model.protocalList[0].econtract_id; 
					APP_Ttl.sn = data.model.sn;
					APP_Ttl.md5 = data.model.protocalList[0].econtract_md5;
				}
			}
		});
	}

	function displayProtocal(){
		mainView.loadPage('/template-3.0/protocal.html?econtract_id='+APP_Ttl.econtractId);
	}
	
	function nextSubmit() {
		if(APP_Ttl.econtractId=="" || APP_Ttl.sn == ""){
			var econtract_type = 8;
			$$.ajax({
				url: '/getEcontractId.do?rnd=' + new Date().getTime(),
				type: 'POST',
				data: { "econtract_type" : econtract_type },
				success: function (data) {
					data = JSON.parse(data);
					if (data.errorNo == 0) {
						APP_Ttl.econtractId = data.model.protocalList[0].econtract_id; 
						APP_Ttl.sn = data.model.sn;
						APP_Ttl.md5 = data.model.protocalList[0].econtract_md5;
						startSign();
					}else{
						khApp.alert(data.errorInfo);
					}
				},
				error: function() {
					khApp.hideIndicator();
		   			khApp.alert(MESSAGE_TIMEOUT);
		   		},
		   		timeout: function() {
		   			khApp.hideIndicator();
		   			khApp.alert(MESSAGE_TIMEOUT);
		   		}
			});
		}else{
			startSign();
		}
	}
	//开始签名
	function startSign(){
		var v = $$('[name=agreement]')[0];
		if(!v.checked){
			APP_Ttl.ttlAccount = "";
			CERT.sign(APP_Ttl.sn, APP_Ttl.md5, "ttlCertSignCallBack");
			return;
		}else{
			//签名
			var cash = $$("input[name=cash]").val();
			 var re = /^[0-9]+.?[0-9]*$/; 
			 if(cash != "" && !re.test(cash)){
				 khApp.alert("金额输入错误！");
				 return;
			 };
			if(cash<200){
				khApp.alert("预留金额不能小于200");
				return;
			}
			APP_Ttl.ttlAccount = "1";
			CERT.sign(APP_Ttl.sn, APP_Ttl.md5, "ttlCertSignCallBack");
		}
	}
	
	
	 //签名回调方法
	   function ttlCertSignCallBack(errorNo, errorInfo, signValue){
		if(errorNo == "-3"){
			khApp.alert("未找到数字证书，请重新下载数字证书");
			return;
		}
		if(errorNo == "-2"){
			khApp.alert("开户协议签名出错，请确认是否正确安装数字证书");
			return;
		}
		if(errorNo == "-1"){
			khApp.alert("数字证书出错，请确认是否正确输入数字证书密码");
			return;
		}
		
		signValue = APP_Ttl.econtractId + ";" + APP_Ttl.md5 + ";" + signValue;
		var cash = $$("input[name=cash]").val();
		//提交
		$$.ajax({
			url: '/setTtlAccount.do?rnd=' + new Date().getTime(),
			type: 'POST',
			timeout: 15000, //超时时间设置，单位毫秒
			data: {
				"ttlAccount" : APP_Ttl.ttlAccount,
				"signValue"    : signValue,
				"cert_sn"      : APP_Ttl.sn,
				"remark"       : cash
				},
			success: function (data) {
				var data = JSON.parse(data);
				if (data.errorNo == 0) {
					mainView.loadPage(APP_Ttl.next);
					//khApp.hideIndicator();
				} else {
					//khApp.hideIndicator();
					khApp.alert(data['errorInfo']);
					$$('.button-fill').prop('disabled', false);
				}
			},
			error: function(){
	   			khApp.alert(MESSAGE_TIMEOUT);
	   			$$('.button-fill').prop('disabled', false);
	   		},
	   		timeout: function(){
	   			khApp.alert(MESSAGE_TIMEOUT);
	   			$$('.button-fill').prop('disabled', false);
	   		}
		});
	}
	
	window.ttlCertSignCallBack = ttlCertSignCallBack;

	function ttlSubmit(){
		var cash = $$("input[name=cash]").val();
		console.info("预留金额："+cash);

		$$.ajax({
			url: '/ttlSubmit.do?rnd=' + new Date().getTime(),
			type: 'POST',
			data: {
				"cash_reserve" : cash
			},
			success: function (data) {
				khApp.hideIndicator();
				data = JSON.parse(data);
				if (data.errorNo === 0) {
					console.info("提交成功");
				}else{
					khApp.alert(data.errorInfo);
				}
			},
			error: function() {
				khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		},
	   		timeout: function() {
	   			khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		}
		});
		
	}
	return {
		init: init
	};
});
