define(['views/verifyView'], function (View) {

  var serialNo = "";
  var APP = {};
  APP.accountNo = "";
  APP.isRebind = "";
  APP.bankName = "";
  var bindings = [{
    element: '.mobile',
    event: 'keyup',
    handler:veriMobile
  },{
    element: '#getCode',
    event: 'click',
    handler:getValidateCode
  },{
    element: '#icbcSubmit',
    event: 'click',
    handler:icbcSubmit
  },{
    element: '#reSelectBank',
    event: 'click',
    handler:goSelectBank
  }];

  function init(query) {
	APP.accountNo = query.bankNo;
	APP.isRebind = query.isRebind;
	APP.bankName = query.bankName;
    khApp.showIndicator();
    $$.ajax({
      url: '/getUserMessage.do?rnd='+new Date().getTime(),
      type: 'GET',
      success: function (data) {
        data = JSON.parse(data);
        console.log(data);
        if (data.errorNo === 0) {
        	if(APP.isRebind == "1"){
        		data.bank_name=APP.bankName;
        		data.bank_account = APP.accountNo;
        	}else{
        		data.bank_name="工商银行短信模式";
        	}
          View.render({
            model: data,
            bindings: bindings
          });
          khApp.hideIndicator();
        }
      }
    });
  }

  function isMobile(str) {
    var reg = /^[1][34578]\d{9}$/;
    return reg.test(str);
  }

  function isVaildCode(str) {
    var reg = /^\d{6}$/;
    return reg.test(str);
  }

  function resetCountdown() {
    if (timer) {
      clearTimeout(timer);
    }
    View.resetBtn();
  }

  function veriMobile() {
    var val = $$(this).val();
    if(isMobile(val)) {
      $$('#getCode').removeClass('disabled');
    }
  }

  function getValidateCode() {
	if(!$$(this).hasClass('disabled')) {
		$$(this).addClass('disabled');
    }
    var valMobile = $$('.mobile').val();
    if(isMobile(valMobile)){
	  //获取验证码	
      goVerify.call(this, valMobile);
      $$('#codeInput').show();
    } else {
      khApp.alert('手机号码有误，请重新输入');
      $$(this).removeClass('disabled');
    }
  }
  
  	//验证码获取时间限制(该功能暂未打开)
	function checkTime(){
		khApp.showPreloader();
		$$.ajax({
			url: '/getNowHour.do?rnd='+new Date().getTime(), 
			method: 'GET', 
			success: function (data) {
				khApp.hidePreloader();
				var data = JSON.parse(data);
				console.log(data);
				if (data.errorNo === 0) {
					//获取验证码在业务办理时间内
					getValidateCode();
				}else{
					khApp.hidePreloader();
					khApp.alert('该业务请您在'+data.sTime+'-'+data.eTime+'之间使用');
				}
			},
			error: function(){
				khApp.hidePreloader();
				khApp.alert(MESSAGE_TIMEOUT);
	 		},
	 		timeout: function(){
	 			khApp.hidePreloader();
	 			khApp.alert(MESSAGE_TIMEOUT);
	 		}
		});
	}
  
  
  

  var timer = null;

  function goVerify(val) {
    var btn = this;
    var setTime = 60;
    var curTime = 0;
    var reqType1=1;
    var bankAccount =  $$('#bankAccount').val();
    //获取验证码
    $$.ajax({
      url: '/verifyMobile.do?rnd='+new Date().getTime(),
      type: 'GET',
      data: {
        'mobile': val,
        'bank_account':bankAccount,
        'reqType':reqType1,
      },
      success: function (data) {
        data = JSON.parse(data);
        console.log(data);
        if (data.errorNo === 0) {
           serialNo = data.serial_no;
           console.log(serialNo);

          countDown(setTime, curTime);
        } else {
        	if(data.errorInfo){
        		khApp.alert(data.errorInfo);
        	}else{
        		khApp.alert("获取验证码失败");
        	}
          resetCountdown();
        }
      },
      error: function () {
        khApp.alert('服务器出错');
        resetCountdown();
      },
      timeout: function () {
        khApp.alert('服务器无响应');
        resetCountdown();
      }
    });
  }

  function countDown(setTime, curTime) {
    var leftTime;

    if (timer) {
      clearTimeout(timer);
    }

    curTime++;
    leftTime = setTime - curTime;
    View.reRenderBtn(leftTime);

    if (leftTime > 0) {
      timer = setTimeout(function () {
        countDown(setTime, curTime);
      }, 1000);
    } else {
      View.resetBtn();
    }
  }
  
  function goSelectBank(){
	  mainView.loadPage("/resetbank?fnf=nextPass&returnVerify=1");
  }
  
  function icbcSubmit() {
	 if(!$$("#icbcSubmit").hasClass('disabled')) {
	   $$("#icbcSubmit").addClass('disabled');
     }
    var valMobile = $$('.mobile').val();
    var smsCode = $$('.code').val();
    var bankAccount =  $$('#bankAccount').val();
    var reqType2=3;
    if (!isMobile(valMobile)) {
      khApp.alert('手机号码为空或有误，请重新输入');
      $$("#icbcSubmit").removeClass('disabled');
      return;
    } else if (!timer) {
      khApp.alert('您还没有获取验证码，请先获取验证码');
      $$("#icbcSubmit").removeClass('disabled');
      return;
    } else if (!isVaildCode(smsCode)) {
      khApp.alert('请输入6位验证码');
      $$("#icbcSubmit").removeClass('disabled');
      return;
    } else {
    	//完成绑定
    	$$.ajax({
	      url: '/verifyMobile.do?rnd='+new Date().getTime(),
	      type: 'GET',
	      data: {
	        'mobile': valMobile,
	        'smsCode': smsCode,
	        'bank_account':bankAccount,
	        'reqType':reqType2,
	        'serialNo':serialNo,
	      },
	      success: function (data) {
	        data = JSON.parse(data);
	        console.log(data);
	        if (data.errorNo === 0) {
	        	//绑定成功
	        	$$("#icbcSubmit").removeClass('disabled');
	        	mainView.loadPage("/exam");
	        } else {
	          $$("#icbcSubmit").removeClass('disabled');
	          khApp.alert(data.errorInfo);
	        }
	      },
	      error: function () {
	        khApp.alert('服务器出错');
	        resetCountdown();
	      },
	      timeout: function () {
	        khApp.alert('服务器无响应');
	        resetCountdown();
	      }
	    });
    }
  }


  return {
    init: init
  };
});
