define(['views/verifyMarkingView'], function (View) {
    var APP_verify = {};
    APP_verify.cookie = "";
    APP_verify.otherPicUploaded = "0";
    var img_desc = "";

    var bindings = [{
        element:'.verify-next-button',
        event: 'click',
        handler: nextStep
    }, {
        element:'.backPhoto',
        event: 'click',
        handler: function () {
            mainView.loadPage("/returnPhoto.do");
        }
    }, {
		element: '#verifyMaterial',
		event: 'click',
		handler: uploadVerif
	}];

    function init() {
        APP_verify.otherPicUploaded = "0";
        APP_verify.cookie = $$("#cookieInput").val();
        var data = {};
        data.userName = $$("#userName").val();
        View.render({
            model: data,
            bindings: bindings
        });
        window.parsePicUrl = parsePicUrl_verify;
        window.rspWeb = rspWeb;
    }
    function thsUpload() {
        khApp.actions([
            [{
                text: '从相册选取',
                color: 'black',
                onClick: function () {
                    uploadSelect(100, "pickAlbum");
                }
            },{
                text: '拍照',
                color: 'black',
                onClick: function () {
                    uploadSelect(100, "photo");
                }
            }],
            [
                {
                    text: '取消',
                    color: 'black'
                }
            ]
        ]);
    }
    function uploadVerif() {
        if(appParams.clientTip == "1"){
            thsUpload();
        }else{
            uploadSelect(100);
        }
    }
    
	function uploadSelect(picType, type) {
		var picTypeStr;
		switch (picType) {
		case 100:
			picTypeStr = "verify";
			break;
		default:
			picTypeStr = "verify";
		}
		if(appParams.clientTip == "1"){
            var action;
            if(type == "photo"){
                action = "takePhoto";
            }else{
                action = "pickAlbum";
            }
            var json = {};
            var dataJson = {};
            dataJson.imgType = "4";
            dataJson.needLocalOcr = "0";
            json.action = action;
            json.reqId = new Date().getTime();
            json.userId = appParams.userId;
            json.param = dataJson;
            window.thskaihu.reqApp(JSON.stringify(json));
        }else{
            if (browser.versions.ios) { // iphone
                window.location.href = "objc://takePictures/?" + picTypeStr + "?"
                    +  APP_verify.cookie;
            } else {
                window.jtoJHandle.takePictures(0,APP_verify.cookie ,picTypeStr);
            }
        }
	}

    /**
     * 同花顺回调接口
     * @param json
     */
    function rspWeb(json){
        var obj = JSON.parse(json);

        //解析返回的图片地址url
        var obj_data = obj.param;
        var action = obj.action;
        if(action == "takePhoto" || action == "pickAlbum"){
            var picType = parseInt(obj_data.imgType);
            var url = encodeURI(obj_data.imgData).replace(/\+/g,'%2B');
            //alert("图片数据="+obj_data.imgData);
            switch(picType){
                case 4:
                    View.showMaterial("data:image/front;base64,"+url);
                    APP_verify.imageBaseVerify = url;
                    APP_verify.otherPicUploaded = "1";
                    break;
                default:
            }
        }else if(action == "jumpApp"){
            alert("jumpApp");
        }

    }
	
	function parsePicUrl_verify(json){
		var obj = eval('(' + json + ')');
		var errNo = obj.errorNo;
//		khApp.alert(errNo+0);
		if (errNo == 0) {
			//解析返回的图片地址url
			var picType = obj.picType;
//			khApp.alert(picType);
			var url = obj.src;
			switch(picType){
				case 'verify':
					View.showMaterial(url);
	                APP_verify.otherPicUploaded = "1";
					break;
					
				default:
			}
		} else {
			khApp.alert(obj.errorInfo);
		}
	}
	
	
	
    function nextStep(){
        $$(".verify-next-button").addClass("disabled");
        if(APP_verify.otherPicUploaded == "0"){
            $$(".verify-next-button").removeClass("disabled");
            khApp.alert("请上传辅助身份证明材料");
            return;
        }
        if(appParams.clientTip == "1"){
            photoSubmit();
        }else{
            CRHloadPage("/callback");
        }
    }

    function photoSubmit(){
        //提交
        $$(".verify-next-button").addClass('disabled');
        khApp.showIndicator();
        $$.ajax({
            url: '/photoSubmit.do?rnd=' + new Date().getTime(),
            type: 'POST',
            timeout: 15000, //超时时间设置，单位毫秒
            data: {
                "imageBaseVerify"  :APP_verify.imageBaseVerify
            },
            success: function (data) {
                khApp.hideIndicator();
                data = JSON.parse(data);
                if (data.errorNo === 0) {
                    stepSync("sendpicOther");
                    CRHloadPage("/callback");
                }  else {
                    khApp.hideIndicator();
                    $$(".verify-next-button").removeClass('disabled');
                    khApp.alert(data.errorInfo);
                }
            },
            error: function() {
                khApp.hideIndicator();
                khApp.alert(MESSAGE_TIMEOUT);
                $$(".verify-next-button").removeClass('disabled');
            },
            timeout: function() {
                khApp.hideIndicator();
                khApp.alert(MESSAGE_TIMEOUT);
                $$(".verify-next-button").removeClass('disabled');
            }
        });
    }
    return {
        init: init
    };
});
