define(['views/videoView', 'GS'], function (View, GS) {
	
	var APP_videoType = {};
	APP_videoType.next		= "/cert";
	APP_videoType.pre  		= "/returnCallback.do";
	
	APP_videoType.userId 	= "";
	
	var bindings = [{
		element: '.video-self',
		event: 'click',
		handler: startSVideo
	},{
        element: '.video-online',
        event: 'click',
        handler: function () {
			mainView.loadPage("/goOnlineVideo.do");
        }
    }];
	
	//下部弹出框按钮事件
	var afterBindings = [];

	function init() {
		var onlySVideo = $$("#onlySVideo").val();

		// 仅支持单向视频
        if(onlySVideo == 1){
        	$$("#videoOnline").hide();
		}
		
		initData();
        window.finishSVideo = finishSVideo;
        window.finishIOSSVideo = finishIOSSVideo;
        window.liveCallback = liveCallback;
		View.render({
			bindings: bindings
		});
		if($$("#openType").val() == appParams.open_type || onlySVideo == "1"){
            startFaceSVideo();
		}
	}
	
	function returnPre(){
		khApp.showIndicator();
		CRHloadPage(APP_videoType.pre);	//上一步
	}
	
	//启动单向视频
	function startSVideo(){
		startFaceSVideo();
	}
	function startNoFaceSvideo(){
		CRHloadPage("/goOfflineVideo.do");
	}
	
	//启动单向视频含人脸识别
	function startFaceSVideo(){
        var json = {};
        json.idCardUrl = $$("#idCardUrl").val(); // 身份证地址
        json.uploadVideoUrl = $$("#videoUploadUrl").val(); // 视频上传地址；
        json.ipAddress = $$("#faceVerifyServer").val(); // 人脸识别服务
        json.cookieDomain = $$("#cookieDomain").val();
        var cookiestr = $$("#cookiestr").val();

        json.thresholdValue = $$("#threshold").val()-0; // 人脸识别分值
        // 授权吗
        json.authCodeString = $$("#authCodeString").val();
        json.appid = $$("#appid").val(); // 授权信息
        json.appSecret = $$("#appSecret").val(); // 授权码

        json.livessNumber = $$("#livessNumber").val(); // 活体检测个数
        json.videoMsg = "本人"+$$("#userName").val()+"自愿在财富证券开户"; // 话术
        json.mPicType = ""; // 暂时无用
        json.recordtime = $$("#recordtime").val(); // 录制时间
        json.policeVerifyUrl = ""; // 公安认证地址
        json.imageBase = $$("#imageBase").val();
        json.cookiestr = cookiestr;
        json.liveCallback = "liveCallback"; // 活体检测保存结果回调
        if (browser.versions.ios) {
            window.location.href = "objc://startSVideoVerify/$?" + JSON.stringify(json)+"$?"+cookiestr;
        } else {

            window.jtoJHandle.startSVideoVerify(JSON.stringify(json));
        }
	}

    // 活体检测保存结果回调
    function liveCallback(json) {
        var data = JSON.parse(json);
        $$.ajax({
            url: "/livingBodyDetect.do?rnd=" + new Date().getTime(),
            method: "POST",
            data: {
                error_no : data.error_no,
                error_info: data.error_info
            },
            success: function () {

            },
            error: function () {
                khApp.alert(MESSAGE_TIMEOUT);
            },
            timeout: function () {
                khApp.alert(MESSAGE_TIMEOUT);
            }
        });
    }

    //android视频录制完成回调
    function finishSVideo(errorNo,errorInfo, videoFilePath, imageBase64){
        var svideoFilePath = videoFilePath;
        if(errorNo ==0){
            khApp.showIndicator();
            mainView.loadPage("/audit?v="+new Date().getTime());
        }else{
            khApp.alert("视频上传不成功，"+errorInfo);
        }
    }


    //IOS 视频录制完成回调
    function finishIOSSVideo(json){
        var obj = JSON.parse(json);
        if(obj.errorNo ==0){
            khApp.showIndicator();
            mainView.loadPage("/audit?v="+new Date().getTime());
        }else{
            khApp.alert("视频上传不成功，"+obj.errorInfo);
        }
    }

	//初始化信息
	function initData(){
		
		APP_videoType.cookieDomain 		= $$("#cookieDomain").val();
		APP_videoType.cookiestr 				= $$("#cookiestr").val();
		APP_videoType.videoUploadUrl 	= $$("#videoUploadUrl").val();
		
		APP_videoType.picUploadUrl 		= $$("#picUploadUrl").val();
		APP_videoType.idCardUrl 		= $$("#idCardUrl").val();
		APP_videoType.faceVerifyServer 		= $$("#faceVerifyServer").val();
		APP_videoType.threshold 		= $$("#threshold").val() - 0;
		APP_videoType.authUrl 		= $$("#authUrl").val();
		
		APP_videoType.userId 	= $$("#clientId").val();//用户ID
		APP_videoType.userName				= $$("#userName").val();
		APP_videoType.showSvideo            = $$("#showSvideo").val();
		
		APP_videoType.videoServer			= $$("#videoServer").val();
		APP_videoType.videoPort				= $$("#videoPort").val()-0;//转int
	}
	
	//通过后下一步
	function videoSuccess() {
		khApp.showIndicator();
		CRHloadPage(APP_videoType.next);
	}
	window.videoSuccess = videoSuccess;
	
	function videoFail() {
		
	}
	//进入在线视频
	function goOnlineVideo() {
		CRHloadPage("/goOnlineVideo.do");
	}

	return {
		init: init
	};
});
