define(['GS'], function (GS) {

	var hash = {
		index       : 'index',
		guide       : 'guide',
		login       : 'login',
		identity    : 'identity',
		collect     : 'collect',
		profile     : 'profile',
		department  : 'department',
		departments : 'departments',
		video       : 'video',
		videoType   : 'videoType',
		svideo      : 'svideo',
		appoint     : 'appoint',
		cert        : 'cert',
		accountList : 'accountList',
		ttl         : 'ttl',
		risk        : 'risk',
		password    : 'password',
		depository  : 'depository',
        depositoryNew  : 'depositoryNew',
		depositoryDetail  : 'depositoryDetail',
		review      : 'review',
		audit       : 'audit',
		protocal    : 'protocal',
		reform      : 'reform',
		prov        : 'prov',
		city        : 'city',
		account     : 'account',
		deps        : 'deps',
		bank        : 'bank',
		verify      : 'verify',
		upload 		: 'upload',
		verifyMarking : 'verifyMarking',
		collectIdcard : 'collectIdcard',
		openResult: 'openResult',
		headShot    : 'headShot',
		riskResult  : 'riskResult',
		auditInfo   : 'auditInfo',
		riskNotice  :  'riskNotice',
		riskConfirm : 'riskConfirm',
        badRecord   : 'badRecord',
        lchCollect  : 'lchCollect',
        lchProfile  : 'lchProfile',
        lchSign     : 'lchSign',
		lchRiskResult: 'lchRiskResult',
		faceDetect  : 'faceDetect',
		appropriateResult  : 'appropriateResult'
	};

	/**
	 * Init router, that handle page events
	 */
	function init() {
		$$(document).on('pageBeforeInit', function (e) {
			var page = e.detail.page;
			if(appParams.clientTip == "1"){
             //   thsload(page.name);
            }
			load(page.name, page.query);
		});
		$$(document).on('click', '.icon-phone', function(){GS.quickDial('95317');});
		$$('.logout').on('click', GS.logout);
		$$('.version').on('click', GS.checkUpdate);
		$$('#clearcache').on('click', GS.clearCache);
		
	    $$('body').on('touchend', function (e) {
			if (e.target.tagName.toUpperCase() !== 'INPUT') {
				$$('input').blur();
			}
		});

        load("login", "");
        if(appParams.clientTip != "1"){
            getAppVersion();
        }
	}

	/**
	 * Load (or reload) controller from js code (another controller) - call it's init function
	 * @param  controllerName
	 * @param  query
	 */
	function load(controllerName, query) {
		if (controllerName in hash) {
			require(['controllers/' + hash[controllerName] + 'Controller'], function (controller) {
				controller.init(query);
				$$('input').blur();
			});
			// 埋点pagetitle的问题,登陆页埋点信息放在登陆成功后，因刚加载时读取不到标题
			setTimeout(function(){
				 wkPageView(controllerName);
            }, 800);
		}
	}
	return {
		init: init,
		load: load
	};
});
