define(['utils', 'text!popup/cert.html'], function (Utils, certPopupTemplate) {

	function render(params) {
		Utils.bindEvents(params.bindings);
	}

	function renderPopup(params) {
		var compiledTemplate = Template7.compile(certPopupTemplate);
		var renderTemplate = compiledTemplate({model: params.model});

		$$('.popup').html(renderTemplate);
		Utils.bindEvents(params.bindings);
	}

	function show(sectionId) {
		$$('.section').hide();
		$$('#' + sectionId).show();
		khApp.closeModal();
	}

	function showDownloading() {
		show('download');
	}

	function showAuditBefore() {
		show('auditBefore');
	}

	function showAuditAfter() {
		show('auditAfter');
	}

	function setProgress(v){
		$$("progress").attr("value",v);
	}
	
	function changeExplainTxt(t){
		$$("#explainTxt").html(t);
	}

	function reSetPassword(){
		$$("#auditBefore").hide();
		$$("#auditAfter").show();
		$$("#download").hide();
		setProgress(20);
	}

	return {
		render: render,
		renderPopup: renderPopup,
		showDownloading: showDownloading,
		showAuditBefore: showAuditBefore,
		showAuditAfter: showAuditAfter,
		setProgress:setProgress,
		reSetPassword:reSetPassword,
		changeExplainTxt:changeExplainTxt
	};
});
