define(['utils'], function (Utils) {

	function init(params) {
		Utils.bindEvents(params.bindings);
	}

	function render(params) {
		var template = $$('#depositoryTemplate').html();
 		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({bankList: params.model.deposityBankList});
		$$('#depositoryContent').html(renderTemplate);
 		Utils.bindEvents(params.bindings);
	}

	function resetSelect() {
		$$('.smart-select select').each(function () {
			this.selectedIndex = -1;
		});
	}

	function noNeedInput() {
        $$('.cardno-input').hide();
        $$('.cardpsw-input').hide();
		$$('#inputGroup').hide();
		$$("input[name=cardNo]").val("");
		$$('#agreeProtocal').show();
		$$('#agreeProtocal').css('display', '-webkit-flex');
	}

	function onlyCardNoInput() {
		$$('#inputGroup').show();
		$$('#agreeProtocal').show();
		$$('#agreeProtocal').css('display', '-webkit-flex');

		$$('.cardno-input').show().addClass('bare');
		$$('.cardpsw-input').hide();
	}

	function bothCardNoPswInput() {
		$$('#inputGroup').show();
		$$('#agreeProtocal').show();
		$$('#agreeProtocal').css('display', '-webkit-flex');

		$$('.cardno-input').show().removeClass('bare');
		$$('.cardpsw-input').show();
	}

	function syncProtocal(text, id) {
		var protocalLink = document.querySelector('#protocalLink');
		replaceQueryId(protocalLink, id);
		$$('#bankName').text(text);
	}

	function replaceQueryId(link, id) {
		link.search = '?econtract_id=' + id;
	}

	return {
		init: init,
		render: render,
		noNeedInput: noNeedInput,
		onlyCardNoInput: onlyCardNoInput,
		bothCardNoPswInput: bothCardNoPswInput,
		syncProtocal: syncProtocal
	};
});
