define(['utils','LArea','LAreaData1','text!popup/risk.html'], function (Utils,LArea,LAreaData,riskPopupTemplate) {

	function init(params) {
		Utils.bindEvents(params.bindings);
	}

	function render(params) {
		var template = $$('#profileTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({model: params.model});

		$$('#profileContent').html(renderTemplate);
		Utils.bindEvents(params.bindings);
		//如果设置联系地址有值，设置联系地址
		var dataJson = params.model;
		var coAddtr = dataJson.uPresence.address;
		var province = dataJson.uPresence.province?dataJson.uPresence.province:"",
			    city = dataJson.uPresence.city?dataJson.uPresence.city:"",
			    dist = dataJson.uPresence.dist?dataJson.uPresence.dist:"";
		var initValue = [0,0,0];//插件初始化位置
		if(coAddtr){//
			if(province&&city){//新版本地址处理
				var str = province+","+city;
				var setValue = province+""+city+""+dist;
				if(dist){
					str = str+","+dist;
				}
				initValue = getIdx(str);
			}else{
				var firstStr = "",secStr = "";
				if(coAddtr.length<13){
					firstStr = coAddtr.substring(0,6);
					secStr = coAddtr.substring(6,coAddtr.length);
				}else{
					firstStr = coAddtr.substring(0,9);
					secStr = coAddtr.substring(9,coAddtr.length);
				}
			}
		}

		var area1 = new LArea();
		area1.init({
			'trigger': '#provAndCity', //触发选择控件的文本框，同时选择完毕后name属性输出到该位置
			'valueTo': '#value1', //选择完毕后id属性输出到该位置
			'opIpt':'#addressDetail',
			'keys': {
				id: 'id',
				name: 'name'
			}, //绑定数据源相关字段 id对应valueTo的value属性输出 name对应trigger的value属性输出
			'type': 1, //数据源类型
			'data': LAreaData //数据源
		});
		area1.value=initValue;//控制初始位置，注意：该方法并不会影响到input的value
		resetSelect();
	}

	function resetSelect() {
		$$('.smart-select select').each(function () {
			this.selectedIndex = -1;
		});
	}
	function renderSearch(params){
		var template = $$('#marketerTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate(params.model);

		$$('.have-result').html('').append(renderTemplate);
	}
	
	function getIdx(str){
	    var arr = str.split(",");
	    var initValue = [0,0,0];
	    if(arr.length==2){
	        for(var i = 0;i<LAreaData.length;i++){
	            if(arr[0]==LAreaData[i].name){
	                initValue[0] = i;
	                var child = LAreaData[i].child;
	                for(var j = 0; j<child.length;j++){
	                    if(arr[1]==child[j].name){
	                        initValue[1] = j;
	                    }
	                }
	            }
	        }
	    }else if(arr.length==3){
	        for(var i = 0;i<LAreaData.length;i++){
	            if(arr[0]==LAreaData[i].name){
	                initValue[0] = i;
	                var child = LAreaData[i].child;
	                for(var j = 0; j<child.length;j++){
	                    if(arr[1]==child[j].name){
	                        initValue[1] = j;
	                        var child2 = child[j].child;
	                        for(var k = 0;k<child2.length;k++){
	                           if(arr[2]==child2[k].name){
	                               initValue[2] = k;
	                           }
	                        }
	                    }
	                }
	            }
	        }
	    }
	    return initValue;
  }
	
	function renderPopup(params) {
		var compiledTemplate = Template7.compile(riskPopupTemplate);
		var renderTemplate = compiledTemplate({model: params.model});

		$$('.popup').html(renderTemplate);
		Utils.bindEvents(params.bindings);
	}
	
	return {
		init: init,
		render: render,
		renderSearch: renderSearch,
		renderPopup: renderPopup
	};
});
