define(['utils'], function (Utils) {
	var videoPopupTemplate_str = 
		
		'<div class="view view-popup navbar-fixed">'+
		'<div class="navbar navbar-red">'+
			'<div class="navbar-inner">'+
				'<div class="center sliding">'+
					'视频验证'+
				'</div>'+
			'</div>'+
		'</div>'+
		'<div class="page">'+
			'<div class="page-content" id="video_pop">'+
			'{{#if model.success}}'+
				'<div class="info-content vertical-align">'+
					'<div class="info"><i class="iconfont icon-success"></i>{{model.successText}}</div>'+
				'</div>'+
				'<div class="content-block">'+
					'<a href="#" class="button button-big active fixed-bottom video-next-button">下一步</a>'+
				'</div>'+
			'{{/if}}'+
			'{{#if model.fail}}'+
				'<div class="info-content vertical-align">'+
					'<div class="info"><i class="iconfont icon-fail"></i>{{model.failText}}</div>'+
				'</div>'+
				'<div class="content-block">'+
					'<a href="#" class="button button-big active fixed-bottom video-retry-button">重新验证</a>'+
				'</div>'+
			'{{/if}}'+
			'</div>'+
		'</div>'+
	'</div>';
	
	var lastStableP = '1';//最后一个稳定的页面1:开始页面;2:单向视频失败页
	
	function render(params) {
		Utils.bindEvents(params.bindings);
	}

	function renderPopup(params) {
		var compiledTemplate = Template7.compile(videoPopupTemplate_str);
		var renderTemplate = compiledTemplate({model: params.model});

		$$('.popup').html(renderTemplate);
		Utils.bindEvents(params.bindings);
		lastStableP = '1';
	}

	function showReady() {
		lastStableP = '1';
		$$('.video-start-button').text("开始视频");
		$$(".wait-num").html('...');
		$$('#readyBack').show();
		$$('#waitLeft').hide();
		$$('#videoContent').show();
		$$('#videoWait').hide();
	}

	function showWait(num,prePage) {
		$$('#readyBack').hide();
		$$('#waitLeft').show();
		$$('#videoContent').hide();
		$$('#videoWait').show();
		if(prePage){
			$$('#waitLeft').data("lastStableP",lastStableP);
		}
		if (num) {
			$$('.wait-num').html(num);
		}
	}
	
	function showReVideo() {
		$$(".wait-num").html('...');
		$$('#readyBack').show();
		$$('#waitLeft').hide();
		$$('#videoContent').show();
		$$('#videoWait').hide();
		$$('.video-start-button').text("视频中断请重新视频");
	}
	/**
	 * 退回到稳定的页面
	 */
    function backLastStableP(){
    	if(lastStableP=='1'){
    		showReady();
    	}else if(lastStableP.substring(0, 1)=='2'){
    		var arg = lastStableP.split('-');
    		showVideoResult(arg[1],arg[2]);
    	}
    }
	// 展示单项视频结果页面
    function showVideoResult(video_mode,error_type) {
    	lastStableP = "2-"+video_mode+"-"+error_type;
    	$$('#readyBack').hide();
		$$('#waitLeft').show();
		$$('#videoContent').hide();
		$$('#videoWait').hide();
    	$$("#videoResultsContent").show();    	
    	if (error_type == "1") {// 检测失败
    		$$("#detected_timeout").hide();
    		$$("#detected_fail").show();
      	  	$$("#re_identity").show();
    		$$("#upload_fail").hide();
    		$$("#re_upload").hide();
    		$$("#identity_fail").hide();
        } else if (error_type == "2") {// 检测超时
      	  	$$("#detected_timeout").show();
      	  	$$("#detected_fail").hide();
    	  	$$("#re_identity").show();
    	  	$$("#upload_fail").hide();
    	  	$$("#re_upload").hide();
    	  	$$("#identity_fail").hide();
        } else if (error_type == "3") {// 人脸认证失败
      	  	$$("#detected_timeout").hide();
      	  	$$("#detected_fail").hide();
    	  	$$("#re_identity").hide();
    	  	$$("#upload_fail").hide();  
    	  	$$("#re_upload").hide();
    	  	$$("#identity_fail").show();
        } else if (error_type == "4") {// 视频上传失败
      	  	$$("#detected_timeout").hide();
      	  	$$("#detected_fail").hide();
    	  	$$("#re_identity").hide();
    	  	$$("#upload_fail").show(); 
    	  	$$("#re_upload").show();
    	  	$$("#identity_fail").hide();      	  	
        } 
    }
    
	/**
	 * 显示隐藏 dialog
	 */
	function toggleDialog(flag) {
		if (flag === 'hide') {
			$$('.dialog').hide();
		} else if (flag === 'show') {
			$$('.dialog').show();
		}
	}
	/**显示单向入口*/
	function showSVideoDoor(f){
		$$(".queue-wait").show();
		if(f){
			$$(".wait-indicator").addClass("next");
	        $$(".wait-hint").addClass("next");
	        $$(".waiting-img").addClass("next");
			$$("#video-self-hint").show();
	        $$(".wait-block .wait-num").addClass("next");
	        $$(".queue-wait-button").show();
		}else{
			$$(".wait-indicator").removeClass("next");
	        $$(".wait-hint").removeClass("next");
	        $$(".waiting-img").removeClass("next");
            $$("#video-self-hint").hide();
            $$(".wait-block .wait-num").removeClass("next");
            $$(".queue-wait-button").hide();
        }
	}
	return {
		render: render,
		renderPopup: renderPopup,
		showWait: showWait,
		showReady: showReady,
		toggleDialog: toggleDialog,
		showReVideo:showReVideo,
		showVideoResult:showVideoResult,
		backLastStableP:backLastStableP,
		showSVideoDoor:showSVideoDoor
	};
});
